<?php namespace Avans;

use Avans\parts\badge;
use Avans\parts\lottery;
use Avans\parts\referer;

class admin
{
    public function __construct()
    {
        add_action('admin_menu', array($this,'avans_add_menu_page'));
        add_action('add_meta_boxes', array($this,'avans_add_meta_boxes'));
        add_action('save_post', array($this,'avans_save_posts'));
        add_filter('gform_form_settings', array($this,'avans_gravity_form_setting'), 99, 2);
        add_filter('gform_pre_form_settings_save', array($this,'avans_save_gravity_form_setting'));
        add_action('gform_entry_detail_sidebar_before', array($this,'avans_add_button_gfrom_increase_score_user'), 10, 2);
        add_action('init', array($this,'admin_init'));
        add_filter('manage_avans-gift_posts_columns', array($this,'avans_gift_columns'));
        add_action('manage_avans-gift_posts_custom_column', array($this,'avans_gift_columns_content'), 10, 2);
        add_action('manage_shop_order_posts_custom_column', array($this,'avans_shop_order_columns_content'), 10, 2);
        add_filter('manage_avans-spin-wheel_posts_columns', array($this,'avans_spin_wheel_columns'));
        add_action('manage_avans-spin-wheel_posts_custom_column', array($this,'avans_spin_wheel_column_content'), 10, 2);
        add_filter('manage_avans-lottery_posts_columns', array($this,'avans_lottery_columns'));
        add_action('manage_avans-lottery_posts_custom_column', array($this,'avans_lottery_columns_content'), 10, 2);
        add_filter('manage_avans-badge_posts_columns', array($this,'avans_badge_columns'));
        add_action('manage_avans-badge_posts_custom_column', array($this,'avans_badge_columns_content'), 10, 2);
        add_action('woocommerce_product_options_advanced', array($this,'avans_product_options_advanced'));
        add_action('woocommerce_variation_options_pricing', array($this,'avans_wc_custom_field_to_variations'), 10, 3);
        add_action("woocommerce_save_product_variation", array($this,'avans_wc_save_product_variation'), 10, 2);
        add_action("woocommerce_process_product_meta", array($this,'avans_wc_process_product_meta'));
        add_action("woocommerce_add_shortcode_show_product_score",array($this,'avans_wc_single_product_summary'),10);
        add_action( 'woocommerce_coupon_options_usage_limit', array($this,'avans_wc_coupon_options_usage_limit'), 10, 2 );
        add_action( 'woocommerce_coupon_options_save', array($this,'avans_wc_coupon_options_save'), 10, 2 );
        add_action( 'woocommerce_admin_order_data_after_order_details', array($this,'avans_show_ref_wc_order_info') );
    }

    public function admin_init(){
        $this->add_post_types();
        $this->define_role_and_caps();
    }

    public function define_role_and_caps(){

        $caps  = array( 
            'manage_avans',
            'manage_avans_options',
            'manage_avans_users',
            'manage_avans_badges',
            'manage_avans_gifts',
            'manage_avans_score_logs',
            'manage_avans_refs_logs',
            'manage_avans_spin_wheels',
            'manage_avans_lottery',
        );

        if( $role_object = get_role( 'administrator' )){
            foreach( $caps as $cap ){
                if( !$role_object->has_cap( $cap )){
                    $role_object->add_cap( $cap );
                }
            }
        }
        

    }


    public function avans_show_ref_wc_order_info($order){
        $get_refere = referer::get_order_referer_by_id($order->ID);
        if($get_refere){
            $user = $get_refere;
        ?>
            <div class="avans_wc_referer_info">
                <div>معرف این سفارش : </div>
                <div class="userData">
                    <div><?php echo get_avatar($user->ID); ?></div>
                    <a href="<?php echo get_edit_user_link($user->ID) ?>">
                        <p><?php echo $user->display_name ?></p>
                        <p><?php echo $user->user_login ?></p>
                    </a>
                </div>
            </div>
        <?php
        }
    }
    
    public function avans_wc_coupon_options_usage_limit( $coupon_id, $coupon ){
        // max discount per coupons
        $max_discount =  get_post_meta( $coupon_id, 'max_discount', true );
        woocommerce_wp_text_input( 
            array(         
                'id'                => 'max_discount',         
                'label'             => __( 'سقف میزان اعمال کد تخفیف', 'woocommerce' ),         
                'placeholder'       => esc_attr( 'مثلا 3000', 'woocommerce' ), 
                'description'       => __( 'سقف میزان تخفیف برای کد تخفیف های درصدی بر اساس واحد پولی ووکامرس', 'woocommerce' ),
                'type'              => 'number',
                'desc_tip'          => true,
                'class'             => 'short',
                'custom_attributes' => array(
                    'step'  => 1,
                    'min'   => 0,
                ),
                'value' => $max_discount ? $max_discount : '',
            ) 
        );
    }

    public function avans_wc_coupon_options_save( $coupon_id, $coupon ) {
        update_post_meta( $coupon_id, 'max_discount', wc_format_decimal( $_POST['max_discount'] ) );
    }

    public function avans_wc_custom_field_to_variations($loop, $variation_data, $variation)
    {
        woocommerce_wp_text_input(array(
                'id' => AVANS_PREFIX.'product_score_var[' . $loop . ']',
                'label' => 'امتیاز به ازای خرید محصول',
                'type' => 'number',
                'value' => get_post_meta($variation->ID, AVANS_PREFIX.'product_score_var', true)
        ));
    }

    public function avans_product_options_advanced()
    {
        woocommerce_wp_text_input([
            'id' => AVANS_PREFIX.'product_score',
            'label' => 'امتیاز به ازای خرید محصول',
            'type' => 'number',
        ]);
    }
    
    public function avans_wc_save_product_variation($variation_id, $i)
    {
        $custom_field = $_POST[AVANS_PREFIX.'product_score_var'][$i];
        if (isset($custom_field)) {
            update_post_meta($variation_id, AVANS_PREFIX.'product_score_var', esc_attr($custom_field));
            update_post_meta($variation_id, AVANS_PREFIX.'product_score', esc_attr($custom_field));
        }
    }

    public function avans_wc_process_product_meta($post_id)
    {
        $product = wc_get_product($post_id);
        $num_score_product = isset($_POST[AVANS_PREFIX.'product_score']) ? $_POST[AVANS_PREFIX.'product_score'] : '';
        $product->update_meta_data(AVANS_PREFIX.'product_score', $num_score_product);
        $product->save();
    }

    public function avans_add_menu_page()
    { 
        add_menu_page(
            __('avans', 'avans_plugin'),
            __('avans', 'avans_plugin'),
            'manage_avans',
            'avans_plugin',
            array($this,'avans_plugin_menu_content'),
            'dashicons-awards',
            45
        );

        if(security::is_activated() !== true){
            return;
        }

        if (update::is_need_update()) {
            add_submenu_page(
                'avans_plugin',
                'به روز رسانی',
                'به روز رسانی',
                'manage_options',
                'avans_update',
                array($this,'avans_update_menu_content')
            );
            return;
        }


        add_submenu_page(
            'avans_plugin',
            'تنظیمات',
            'تنظیمات',
            'manage_avans_options',
            'avans_plugin_settings',
            array($this,'avans_plugin_settings_menu_content')
        );

        add_submenu_page(
            'avans_plugin',
            'کاربران',
            'کاربران',
            'manage_avans_users',
            'avans_users_actions',
            array($this,'avans_users_actions_menu_content')
        );

        remove_menu_page('edit.php?post_type=avans-badge');
        add_submenu_page(
            'avans_plugin',
            'نشان ها',
            'نشان ها',
            'manage_avans_badges',
            'edit.php?post_type=avans-badge'
        );

        remove_menu_page('edit.php?post_type=avans-gift');
        add_submenu_page(
            'avans_plugin',
            'جوایز و هدایا',
            'جوایز و هدایا',
            'manage_avans_gifts',
            'edit.php?post_type=avans-gift'
        );

        remove_menu_page('edit.php?post_type=avans-spin-wheel');
        add_submenu_page(
            'avans_plugin',
            'گردونه شانس',
            'گردونه شانس',
            'manage_avans_spin_wheels',
            'edit.php?post_type=avans-spin-wheel'
        );

        remove_menu_page('edit.php?post_type=avans-lottery');
        add_submenu_page(
            'avans_plugin',
            'قرعه کشی',
            'قرعه کشی',
            'manage_avans_lottery',
            'edit.php?post_type=avans-lottery'
        );

        add_submenu_page(
            'avans_plugin',
            'گزارشات امتیاز',
            'گزارشات امتیاز',
            'manage_avans_score_logs',
            'avans_log_actions',
            array($this,'avans_log_actions_menu_content')
        );
    
        add_submenu_page(
            'avans_plugin',
            'گزارشات بازاریابی',
            'گزارشات بازاریابی',
            'manage_avans_refs_logs',
            'avans_log_refs',
            array($this,'avans_log_refs_menu_content')
        );

        add_submenu_page(
            'avans_plugin',
            'گزارشات جوایز',
            'گزارشات جوایز',
            'manage_avans_gifts',
            'avans_log_gifts',
            array($this,'avans_log_gifts_menu_content')
        );

    }

    public function avans_update_menu_content(){
        include AVANS_PATH.'/templates/admin/settings/update.php';
    }

    public function add_post_types()
    {
        if(security::is_activated() !== true || update::is_need_update()){
            return;
        }

        $labels = array(
        'name'                => 'جوایز',
        'singular_name'       => 'جایزه',
        'menu_name'           => 'جوایز',
        'all_items'           => 'همه جوایز',
        'view_item'           => 'نمایش',
        'add_new_item'        => 'افزودن جایزه جدید',
        'add_new'             => 'افزودن',
        'edit_item'           => 'ویرایش جایزه',
        'update_item'         => 'به روزرسانی جایزه',
        'search_items'        => 'جستجو',
        'not_found'           => 'هیچ جایزه ای پیدا نشد!',
        'not_found_in_trash'  => 'هیچ جایزه ای در زباله دان پیدا نشد!'
        );
        register_post_type('avans-gift', array(
        'label'               => 'جوایز',
        'description'         => 'تعریف جایزه برای افزونه آوانس',
        'labels'              => $labels,
        'supports'            => array('title','editor','thumbnail'),
        'hierarchical'        => false,
        'public'              => false,
        'show_ui'             => true,
        'show_in_menu'        => false,
        'show_in_nav_menus'   => true,
        'show_in_admin_bar'   => true,
        'menu_position'       => 5,
        'can_export'          => true,
        'has_archive'         => false,
        'exclude_from_search' => true,
        'publicly_queryable'  => false,
        'capability_type'     => 'post',
        // 'show_in_rest' => true,
        ));


        $labels = array(
        'name'                => 'گردونه شانس',
        'singular_name'       => 'گردونه شانس',
        'menu_name'           => 'گردونه شانس',
        'all_items'           => 'همه گردونه های شانس',
        'view_item'           => 'نمایش',
        'add_new_item'        => 'افزودن گردونه جدید',
        'add_new'             => 'افزودن',
        'edit_item'           => 'ویرایش گردونه',
        'update_item'         => 'به روزرسانی گردونه شانس',
        'search_items'        => 'جستجو',
        'not_found'           => 'هیچ گردونه شانسی پیدا نشد!',
        'not_found_in_trash'  => 'هیچ گردونه شانسی در زباله دان پیدا نشد!'
        );
        register_post_type('avans-spin-wheel', array(
        'label'               => 'گردونه های شانس',
        'description'         => 'تعریف گردونه شانس برای افزونه آوانس',
        'labels'              => $labels,
        'supports'            => array('title'),
        'hierarchical'        => false,
        'public'              => false,
        'show_ui'             => true,
        'show_in_menu'        => false,
        'show_in_nav_menus'   => true,
        'show_in_admin_bar'   => true,
        'menu_position'       => 5,
        'can_export'          => true,
        'has_archive'         => false,
        'exclude_from_search' => true,
        'publicly_queryable'  => false,
        'capability_type'     => 'post',
        // 'show_in_rest' => true,
        ));


        $labels = array(
        'name'                => 'قرعه کشی',
        'singular_name'       => 'قرعه کشی',
        'menu_name'           => 'قرعه کشی',
        'all_items'           => 'همه قرعه کشی ها',
        'view_item'           => 'نمایش',
        'add_new_item'        => 'افزودن قرعه کشی جدید',
        'add_new'             => 'افزودن',
        'edit_item'           => 'ویرایش قرعه کشی',
        'update_item'         => 'به روزرسانی قرعه کشی',
        'search_items'        => 'جستجو',
        'not_found'           => 'هیچ قرعه کشی پیدا نشد!',
        'not_found_in_trash'  => 'هیچ قرعه کشی در زباله دان پیدا نشد!'
        );

        register_post_type('avans-lottery', array(
        'label'               => 'قرعه کشی',
        'description'         => 'ایجاد قرعه کشی برای افزونه آوانس',
        'labels'              => $labels,
        'supports'            => array('title','editor'),
        'hierarchical'        => false,
        'public'              => false,
        'show_ui'             => true,
        'show_in_menu'        => false,
        'show_in_nav_menus'   => true,
        'show_in_admin_bar'   => true,
        'menu_position'       => 5,
        'can_export'          => true,
        'has_archive'         => false,
        'exclude_from_search' => true,
        'publicly_queryable'  => false,
        'capability_type'     => 'post',
        // 'show_in_rest' => true,
        ));


        $labels = array(
        'name'                => 'نشان ها',
        'singular_name'       => 'نشان',
        'menu_name'           => 'نشان ها',
        'all_items'           => 'همه نشان ها',
        'view_item'           => 'نمایش',
        'add_new_item'        => 'افزودن نشان جدید',
        'add_new'             => 'افزودن',
        'edit_item'           => 'ویرایش نشان',
        'update_item'         => 'به روزرسانی نشان',
        'search_items'        => 'جستجو',
        'not_found'           => 'هیچ نشانی پیدا نشد!',
        'not_found_in_trash'  => 'هیچ نشانی در زباله دان پیدا نشد!'
        );

        register_post_type('avans-badge', array(
        'label'               => 'نشان ها',
        'description'         => 'ایجاد نشان برای افزونه آوانس',
        'labels'              => $labels,
        'supports'            => array('title','thumbnail'),
        'hierarchical'        => false,
        'public'              => false,
        'show_ui'             => true,
        'show_in_menu'        => false,
        'show_in_nav_menus'   => true,
        'show_in_admin_bar'   => true,
        'menu_position'       => 5,
        'can_export'          => true,
        'has_archive'         => false,
        'exclude_from_search' => true,
        'publicly_queryable'  => false,
        'capability_type'     => 'post',
        // 'show_in_rest' => true,
        ));
    }

    public function avans_plugin_menu_content(){
        if(security::is_activated() !== true){
            wp_safe_redirect(admin_url('admin.php?page=avans_guard'));
            return;
        }

        if(update::is_need_update()){
            wp_safe_redirect(admin_url('admin.php?page=avans_update'));
            return;
        }
        
        wp_safe_redirect(admin_url('admin.php?page=avans_plugin_settings'));
    }

    public function avans_log_gifts_menu_content(){
        include_once AVANS_PATH.'/templates/admin/settings/gifts-log/log.php';
    }

    public function avans_log_refs_menu_content(){
        include_once AVANS_PATH.'/templates/admin/settings/refs-log/log.php';
    }

    public function avans_plugin_settings_menu_content()
    {
        include_once AVANS_PATH.'/templates/admin/settings/index/index.php';
    }

    public function avans_log_actions_menu_content()
    {
        include_once AVANS_PATH.'/templates/admin/settings/log/log.php';
    }

    public function avans_add_meta_boxes()
    {
        add_meta_box(
            'avs_score_page',
            'امتیاز سفارشی برای مشاهده این برگه',
            array($this,'avans_score_page_settings'),
            'page',
            'advanced',
            'high'
        );
        add_meta_box(
            'avans_custom_settings_gifts',
            'تنظیمات جایزه',
            array($this,'avans_custom_settings_gifts_callback'),
            'avans-gift',
            'advanced',
            'high'
        );
        add_meta_box(
            'avans_custom_settings_spin_wheels',
            'تنظیمات گردونه شانس',
            array($this,'avans_custom_settings_spin_wheels_callback'),
            'avans-spin-wheel',
            'advanced',
            'high'
        );
        add_meta_box(
            'avans_custom_settings_spin_wheels',
            'تنظیمات قرعه کشی',
            array($this,'avans_custom_settings_lottery_callback'),
            'avans-lottery',
            'advanced',
            'high'
        );
        add_meta_box(
            'avans_shortcode_lottery',
            'کد کوتاه ثبت نام قرعه کشی',
            array($this,'avans_shortcode_lottery_callback'),
            'avans-lottery',
            'side',
            'high'
        );
        add_meta_box(
            'avans_shortcode_spin_wheels',
            'کد کوتاه نمایش گردونه شانس',
            array($this,'avans_shortcode_spin_wheels_callback'),
            'avans-spin-wheel',
            'side',
            'high'
        );
        add_meta_box(
            'avans_badge_settings_metabox',
            'تنظیمات نشان',
            array($this,'avans_badge_settings_metabox_callback'),
            'avans-badge',
            'advanced',
            'high'
        );
        add_meta_box(
            'avans_badge_settings_metabox',
            'معرف سفارش',
            array($this,'avans_order_ref_user_metabox_callback'),
            'shop_order',
            'side',
            'core'
        );
        add_meta_box(
            'avans_pageLock_settings_metabox',
            'تنظیمات محدودیت صفحه به کاربران خاص',
            array($this,'avans_pageLock_settings_metabox_callback'),
            array('post','page','course','product'),
            'advanced',
            'core'
        );

    }

    public function avans_pageLock_settings_metabox_callback($post){
        $settings =  get_post_meta($post->ID, AVANS_PREFIX.'page_lock_settings', true);
        include_once AVANS_PATH.'templates/admin/metaboxes/avs-post-lock.php';
    }

    public function avans_order_ref_user_metabox_callback($post){
        include_once AVANS_PATH.'templates/admin/metaboxes/avs-ref-order-details.php';
    }

    public function avans_badge_settings_metabox_callback($post)
    {
        $settings = (array)get_post_meta($post->ID, AVANS_PREFIX.'badge_settings', true);
        include_once AVANS_PATH.'templates/admin/metaboxes/avs-badge-settings.php';
    }

    public function avans_shortcode_lottery_callback($post)
    {
        ?>
      <input disabled class="show_shortcode_spin_wheel_avans" type="text" value="[avans-lottery id=<?php echo $post->ID; ?>]">
      <?php
    }

    public function avans_custom_settings_lottery_callback($post)
    {
        $settings = (array)get_post_meta($post->ID, AVANS_PREFIX.'lottery_settings', true);
        include_once AVANS_PATH.'templates/admin/metaboxes/avs-lottery-settings.php';
    }

    public function avans_custom_settings_spin_wheels_callback($post)
    {
        $settings = (array)get_post_meta($post->ID, AVANS_PREFIX.'spin_wheel_settings', true);
        include_once AVANS_PATH.'templates/admin/metaboxes/avs-spin-wheel-settings.php';
    }

    public function avans_shortcode_spin_wheels_callback($post)
    {
        ?>
      <input disabled class="show_shortcode_spin_wheel_avans" type="text" value="[avans-spin-wheel id=<?php echo $post->ID; ?>]">
      <?php
    }

    public function avans_custom_settings_gifts_callback($post)
    {
        $data = (array)get_post_meta($post->ID, AVANS_PREFIX.'gift_settings', true);
        include_once AVANS_PATH.'templates/admin/metaboxes/avs-gift-settings.php';
    }

    public function avans_score_page_settings($post)
    {
        $data = (array)get_post_meta($post->ID, AVANS_PREFIX.'meta_score_page', true);
        include_once AVANS_PATH.'templates/admin/metaboxes/avs-score-page.php';
    }

    public function avans_save_posts($post_id)
    {
        if (get_post_type($post_id) == 'page') {
            $meta = [];
            $meta['active'] = isset($_POST['avans_page_is_active']) ? true : false;
            $meta['score']  = $_POST['avans_page_score'];
            $meta['delay']  = $_POST['avans_page_delay'];
            $meta['text']   = $_POST['avans_page_text'];
            update_post_meta($post_id, AVANS_PREFIX.'meta_score_page', $meta);
        }

        if (get_post_type($post_id) == 'avans-gift' && isset($_POST['avans_type_gift']) ) {
            $meta = [];
            $meta['score_for_get_gift'] = $_POST['score_for_get_gift'];
            $meta['avans_type_gift'] = $_POST['avans_type_gift'];

            switch ($meta['avans_type_gift']) {
                case 'coupon':
                    $meta['number_of_charecter_coupen'] = $_POST['number_of_charecter_coupen'];
                    $meta['expire_date_coupen'] = $_POST['expire_date_coupen'];
                    $meta['value_percent_coupen'] = $_POST['value_percent_coupen'];
                    $meta['avans_type_coupon_gift'] = $_POST['avans_type_coupon_gift'];
                    $meta['min_price_for_coupen'] = $_POST['min_price_for_coupen'];
                    $meta['max_price_for_coupen'] = $_POST['max_price_for_coupen'];
                    $meta['prefix_coupen'] = $_POST['prefix_coupen'];
                    $meta['exclude_sale_product'] = isset($_POST['exclude_sale_product']) ? true : false;
                    $meta['max_discount_coupon'] = $_POST['max_discount_coupon'];
                    $meta['limited_custom_product_for_copon'] = $_POST['limited_custom_product_for_copon'];
                    $meta['limited_custom_category_for_copon'] = $_POST['limited_custom_category_for_copon'];
                    $meta['exclude_custom_category_for_copon'] = $_POST['exclude_custom_category_for_copon'];
                    $meta['exclude_custom_product_for_copon'] = $_POST['exclude_custom_product_for_copon'];
                break;
                case 'product':
                    $meta['select_product_for_gift'] = $_POST['select_product_for_gift'];
                    $meta['get_shipping_info'] =  $_POST['get_shipping_info'];
                break;
                case 'file':
                    $files = json_decode(stripslashes($_POST['download_file_link_for_gift']));
                    $meta['download_file_link_for_gift'] = $files;
                break;
                case 'custom':
                    $custom_content = str_replace(array("\r\n", "\r"), "\n", $_POST['custom_content_for_gift']);
                    $custom_content = str_replace(array('\"'), '', $custom_content);
                    $custom_content = wpautop($custom_content);
                    $meta['custom_content_for_gift'] = $custom_content;
                    $gift_setting['is_active_update_custom_content_gift'] = $_POST['is_active_update_custom_content_gift'];
                break;
            }

            update_post_meta($post_id, AVANS_PREFIX.'gift_settings', $meta);
            update_post_meta($post_id, AVANS_PREFIX.'gift_score', $_POST['score_for_get_gift']);
            update_post_meta($post_id, AVANS_PREFIX.'gift_type', $_POST['avans_type_gift']);
        }

        if (get_post_type($post_id) == 'avans-spin-wheel' && isset($_POST['avans_spin_wheel_settings_all']) ) {
            $data = [
                'slices' => json_decode(stripslashes($_POST['avans_spin_wheel_settings_all'])),
                'score' => $_POST['avans_spin_wheel_score'],
                'is_active_free_spin' => $_POST['is_active_free_spin'],
                'style' => array(
                    'primary_color' => $_POST['primary_color_spinwheel'],
                    'secondry_color' => $_POST['secondry_color_spinwheel'],
                    'text_center_color' =>  $_POST['color_text_center_spinwheel'],
                ),
            ];

            if($data['is_active_free_spin']){
                $data['duration'] = [
                    'value' => $_POST['avans_spin_wheel_duration_value'],
                    'unit' => $_POST['avans_spin_wheel_duration_unit'],
                ];
            }

            update_post_meta($post_id, AVANS_PREFIX.'spin_wheel_settings', $data);
        }

        if (get_post_type($post_id) == 'avans-lottery') {
            $data = [
                'score' => isset($_POST['score_lottery']) ? $_POST['score_lottery'] : '',
                'max_chance' => isset($_POST['max_chance_lottery']) ? $_POST['max_chance_lottery'] : '',
                'date' => isset($_POST['time_lottery']) ? $_POST['time_lottery'] : '',
                'awards' => isset($_POST['avans_lottery_settings_all']) ? json_decode(stripslashes($_POST['avans_lottery_settings_all'])) : null,
            ];
            update_post_meta($post_id, AVANS_PREFIX.'lottery_settings', $data);
        }

        if (get_post_type($post_id) == 'avans-badge' && isset($_POST['avans_badge_settings_all']) ) {
            $data = [
                'steps' => json_decode(stripslashes($_POST['avans_badge_settings_all'])),
                // 'score' => $_POST['badge_score'],
                // 'expire' => array(
                //     'value' => $_POST['value_expire_score'],
                //     'unit' => $_POST['unit_expire_score'],
                // ),
            ];
            update_post_meta($post_id, AVANS_PREFIX.'badge_settings', $data);
        }


        if(
            isset($_POST['avans_pageLock_is_active']) ||
            isset($_POST['avans_pageLock_score']) ||
            (isset($_POST['avans_select_user_level_for_open_lock']) && $_POST['avans_select_user_level_for_open_lock'] != 'unset') ||
            isset($_POST['avans_select_user_roles_for_open_lock']) ||
            isset($_POST['avans_select_user_badges_for_open_lock'])
        ){

            $argsPageLock = [
                'active' => isset($_POST['avans_pageLock_is_active']) ? true : false,
                'score' => $_POST['avans_pageLock_score'],
                'level' => $_POST['avans_select_user_level_for_open_lock'],
                'roles' => $_POST['avans_select_user_roles_for_open_lock'],
                'badges' => $_POST['avans_select_user_badges_for_open_lock'],
            ];
            update_post_meta($post_id, AVANS_PREFIX.'page_lock_settings', $argsPageLock);
        }


    }

    public function avans_badge_columns($column){
        unset($columns['date']);
        unset($columns['title']);
        $columns['title'] = 'عنوان نشان';
        $columns['image'] = 'تصویر نشان';
        $columns['steps'] = 'تعداد مراحل کسب نشان';
        $columns['date'] = 'تاریخ ایجاد';
        return $columns;
    }

    public function avans_badge_columns_content($column, $post_id)
    {
        $data = (array)get_post_meta($post_id, AVANS_PREFIX.'spin_wheel_settings', true);
        switch ($column) {
        case 'image':
            echo get_the_post_thumbnail($post_id,'avans_badge_small');
            break;
        case 'title':
            echo get_the_title($post_id);
            break;
        case 'steps':
            echo count((array) badge::get_badge_steps($post_id));
            break;
        }
    }

    public function avans_lottery_columns($columns)
    {
        unset($columns['date']);
        unset($columns['title']);
        $columns['title'] = 'عنوان قرعه کشی';
        $columns['status'] = 'وضعیت';
        $columns['members'] = 'اعضا';
        $columns['operation'] = 'عملیات';
        $columns['date'] = 'تاریخ ایجاد';
        return $columns;
    }

    public function avans_shop_order_columns_content($column, $post_id){
        $order = wc_get_order( $post_id );
        $is_prize = get_post_meta($post_id,AVANS_PREFIX.'is_order_prize',true);
        if($column == 'order_status' && $is_prize == 'true'){
            echo '<i class="order-status status-'.$order->get_status().' avans_is_order_prize avans-ic avs-icon-gift">جایزه</i>';
        }

    }

    public function avans_lottery_columns_content($column, $post_id)
    {
        $options = get_post_meta($post_id, AVANS_PREFIX.'lottery_settings', true);
        $members = (array)get_post_meta($post_id, AVANS_PREFIX.'lottery_members', true);
        $members_count = array_count_values($members);
        unset($members_count['']);
        switch ($column) {
        case 'members':
            echo count($members_count).'<span class="dashicons dashicons-visibility" data-id="'.$post_id.'" data-ajax="'.admin_url('admin-ajax.php').'"></span>';
            break;
        case 'status':
            if (empty(lottery::get_winners($post_id))):
                echo "<span class='lottery_label_status'>در حال ثبت نام</span>";
            else:
                echo "<span class='lottery_label_status'>تکمیل شده</span>";
            endif;
        break;
        case 'operation':
          ?>
              <div class="operation">
                <?php if (empty(lottery::get_winners($post_id))): ?>
                <button class="avnas_run_lottery button" data-id="<?php echo $post_id ?>" data-ajax="<?php echo admin_url('admin-ajax.php') ?>">انجام قرعه کشی</button>
                <?php else: ?>
                <button class="avnas_report_lottery button" data-id="<?php echo $post_id ?>" data-ajax="<?php echo admin_url('admin-ajax.php') ?>" >گزارش قرعه کشی</button>
                <?php endif; ?>
              </div>
          <?php
        break;
 
        }
    }

    public function avans_spin_wheel_columns($columns)
    {
        unset($columns['date']);
        unset($columns['title']);
        $columns['title'] = 'عنوان گردونه';
        $columns['score'] = 'امتیاز لازم برای هر چرخش';
        $columns['count_prize'] = 'تعداد جوایز';
        $columns['date'] = 'تاریخ ایجاد';
        return $columns;
    }

    public function avans_spin_wheel_column_content($column, $post_id)
    {
        $data = (array)get_post_meta($post_id, AVANS_PREFIX.'spin_wheel_settings', true);
        switch ($column) {
        case 'score':
            echo (int)$data['score'];
            break;
        case 'count_prize':
            echo (int) count((array)$data['slices']);
            break;
        }
    }

    public function avans_gift_columns($columns)
    {
        unset($columns['date']);
        unset($columns['title']);
        $columns['title'] = 'عنوان جایزه';
        $columns['score'] = 'امتیاز لازم';
        $columns['type'] = 'نوع جایزه';
        $columns['date'] = 'تاریخ ایجاد';
        return $columns;
    }

    public function avans_gift_columns_content($column, $post_id)
    {
        $data = get_post_meta($post_id, AVANS_PREFIX.'gift_settings', true);
        switch ($column) {
        case 'score':
            echo @strval($data['score_for_get_gift']);
            break;
        case 'type':
            $type =  @strval($data['avans_type_gift']);
            $type_gift = '';
            switch ($type) {
                case 'coupon':
                    $type_gift = '<span class="label_gift_type coupon">'.'کوپن تخفیف'.'</span>';
                break;
                case 'product':
                    $type_gift = '<span class="label_gift_type product">'.'محصول'.'</span>';
                break;
                case 'file':
                    $type_gift = '<span class="label_gift_type file">'.'فایل'.'</span>';
                break;
                case 'custom':
                    $type_gift = '<span class="label_gift_type custom">'.'محتوای سفارشی'.'</span>';
                break;
                default:
                break;
            }
            echo $type_gift ;
            break;

    
        }
    }


    public function avans_gravity_form_setting($settings, $form)
    {
        $settings[ __('تنظیمات امتیاز فرم', 'gravityforms') ]['avans_score_value_gravity_form']= '
        <tr>
            <th><label for="avans_score_value_gravity_form">امتیاز تکمیل فرم</label></th>
            <td><input type="number" class="fieldwidth-3" value="' . rgar($form, 'avans_score_value_gravity_form') . '" name="avans_score_value_gravity_form"></td>
        </tr>';

        $settings[ __('تنظیمات امتیاز فرم', 'gravityforms') ]['avans_score_text_gravity_form']= '
        <tr>
            <th scope="row">متن پیام اعلان</th>
            <td><input class="fieldwidth-3" type="text" name="avans_score_text_gravity_form" placeholder="تبریک شما {score} امتیاز گرفتید!" value="' . rgar($form, 'avans_score_text_gravity_form') . '">
            <p>برای نمایش میزان امتیاز می توانید از کد کوتاه {score} استفاده کنید</p>
            </td>
        </tr>';

        $settings[ __('تنظیمات امتیاز فرم', 'gravityforms') ]['avans_score_status_gravity_form']= '
        <tr>
            <th scope="row">وضعیت امتیازدهی</th>
            <td>
            <label>
                <input class="" type="radio" name="avans_score_status_gravity_form" value="after_send_entry"   '.checked(rgar($form, 'avans_score_status_gravity_form'), 'after_send_entry', false).'    checked="checked">
                بعد از ارسال فرم
            </label>
            <label>
                <input class="" type="radio" name="avans_score_status_gravity_form" value="after_verify_entry" '.checked(rgar($form, 'avans_score_status_gravity_form'), 'after_verify_entry', false).'   >
                بعد از تایید مدیر
            </label>
            </td>
        </tr>';


        $settings[ __('تنظیمات امتیاز فرم', 'gravityforms') ]['avans_score_repeat_gravity_form']= '
        <tr>
            <th scope="row">امتیازدهی مجدد</th>
            <td>
            <label>
                <input class="" type="checkbox" name="avans_score_repeat_gravity_form" value="yes"   '.checked(rgar($form, 'avans_score_repeat_gravity_form'), 'yes', false).'  >
            فعال
            </label>
            <p>کاربرانی که قبلا این فرم را پر کرده اند امکان امتیازگیری مجدد دارند!</p>
            </td>
        </tr>';


        return $settings;

    }

    public function avans_save_gravity_form_setting($form)
    {
        $form['avans_score_value_gravity_form'] = rgpost('avans_score_value_gravity_form');
        $form['avans_score_text_gravity_form'] = rgpost('avans_score_text_gravity_form');
        $form['avans_score_status_gravity_form'] = rgpost('avans_score_status_gravity_form');
        $form['avans_score_repeat_gravity_form'] = rgpost('avans_score_repeat_gravity_form') ;
        return $form;
    }

    public function avans_users_actions_menu_content()
    {
        include_once AVANS_PATH.'/templates/admin/settings/users/users.php';
    }

    public function avans_add_button_gfrom_increase_score_user($form, $entry)
    {
        include_once AVANS_PATH.'templates/admin/integrations/gravity-form/details-entry.php';
    }
}
