<?php namespace Avans;

class func
{
    public static function calc_date_persian($timestamp,$time = null)
    {
        $t = time();
        if(isset($time) && $time > 0){
            $t = $time;
        }
        // return $t;
        return avans_date('Y/m/d', $t + $timestamp);
    }

    public static function get_correct_time_database($time, $type=null)
    {
        $date = get_option('timezone_string') == 'Asia/Tehran' ? avans_date('Y/m/d h:i:s', strtotime($time), '', 'GMT') :  date('Y/m/d h:i:s', strtotime($time));
        if (!is_null($type)) {
            if ($type == 'date'):
                $date = explode(' ', $date)[0];
            elseif ($type == 'whatch') :
                $date = end(explode(' ', $date));
            endif;
        }
        return $date;
    }

    public static function getDate(string $dbDate,$limit = null){

        if(get_option('timezone_string') == 'Asia/Tehran'){

            if($limit == 'hour'){
                return avans_date('h:i:s', strtotime($dbDate), '', 'GMT','en');
            }
            if($limit == 'date'){
                return avans_date('Y/m/d', strtotime($dbDate), '', 'GMT','en');
            }
            return avans_date('Y/m/d h:i:s',strtotime($dbDate), '', 'GMT','en');


        }else{

            if($limit == 'hour'){
                return date('h:i:s', strtotime($dbDate));
            }
            if($limit == 'date'){
                return date('Y/m/d', strtotime($dbDate));
            }

            return date('Y/m/d h:i:s', strtotime($dbDate));
        }


    }

    public static function get_from_DBdate_by_string($key){
        
        $timestamp = 0;
         switch ($key) {
            case 'daily':
                $timestamp = 60*60*24;
            break;
            case 'weekly':
                $timestamp = 60*60*24*7;
            break;
            case 'monthly':
                $timestamp = 60*60*24*30;
            break;
            case 'seasonal':
                $timestamp = 60*60*24*30*3;
            break;
            case 'yearly':
                $timestamp = 60*60*24*365;
            break;
        }

        $from = time() - $timestamp;
        return date('Y-m-d H:i:s',$from);      
    }


    public static function get_score_icon($size = 24){
        $icon = ( null !== AVANS_SETTINGS['general_settings']['score']['icon'] && !empty(AVANS_SETTINGS['general_settings']['score']['icon'])) ? AVANS_SETTINGS['general_settings']['score']['icon'] : false;
        if( $icon ):
            return "<img class='score-icon' src='$icon' width='$size' height='$size'>";
        else:
            return "<i class='avans-ic avs-icon-gem-solid'></i>";
        endif;
    }

    public static function get_score_label($s = false){
        $label = ( null !== AVANS_SETTINGS['general_settings']['score']['label'] && !empty(AVANS_SETTINGS['general_settings']['score']['label'])) ? AVANS_SETTINGS['general_settings']['score']['label'] : false;
        if( $label ):
            if($s){
               return $label.' ها'; 
            }
            return $label;
        else:
            if($s){
               return 'امتیاز ها'; 
            }
            return "امتیاز";
        endif;
    }

    public static function convert_jalali_to_miladi($date)
    {
        if (isset($date) && !empty($date)) {
            $date = explode('/', $date);
            $date = avans_date_jalali_to_gregorian((int)avans_tr_num($date['0']), (int)avans_tr_num($date['1']), (int)avans_tr_num($date['2']), '-');
        }
        if(is_array($date)){
            $date = $date[0].'-'.$date[1].'-'.$date[2];
        }
        return $date;
    }

     
    public static function is_valid_mobile_number($mobile){
        return preg_match('/^[0-9]{11}+$/', $mobile);
    }


    public static function convert_miladi_to_jalali($date)
    {
        $date = explode('-', $date);
        $date = avans_date_gregorian_to_jalali((int)$date['0'], (int)$date['1'], (int)$date['2'], '/');
        if(is_array($date)){
            $date = $date[0].'/'.$date[1].'/'.$date[2];
        }
        return $date;
    }

    public static function diference_time_now($date)
    {
        $timestamp = strtotime($date);
        if ($timestamp !== 0) {
            date_default_timezone_set("UTC + 3:30");
            return $timestamp - time();
        }
    }

    public static function get_time_stamp($date)
    {
        $d = \DateTime::createFromFormat('Y-m-d H:i:s', $date.':00', new \DateTimeZone('Asia/Tehran'));
        if ($d === false) {
            return 0;
        } else {
            return $d->getTimestamp();
        }
    }

    public static function get_gform_title($form_id)
    {
        if (class_exists('RGFormsModel')) {
            $forminfo = (object)\RGFormsModel::get_form($form_id);
            return $forminfo->title;
        }
        return '';
    }


    public static function diference_time_now_for_date_db($date)
    {
        $timestamp = self::get_time_stamp_for_date_db($date);
        if ($timestamp !== 0) {
            date_default_timezone_set("UTC + 3:30");
            return $timestamp - time();
        }
    }

    public static function get_time_stamp_for_date_db($date)
    {
        $d = \DateTime::createFromFormat('Y-m-d H:i:s', $date, new \DateTimeZone('Asia/Tehran'));
        if ($d === false) {
            return 0;
        } else {
            return $d->getTimestamp();
        }
    }

    public static function covert_string_time_to_timestamp($unit)
    {
        switch ($unit) {
            case 'min':
                return 60;
            break;
            case 'hour':
                return 60*60;
            break;
            case 'day':
                return 60*60*24;
            break;
            case 'week':
                return 60*60*24*7;
            break;
            case 'month':
                return 60*60*24*30;
            break;
            case 'year':
                return 60*60*24*365;
            break;
        }
    }


    public static function get_array_without_empty(array $array)
    {
        $data = array_filter($array, function ($value) {
            return !is_null($value) && $value !== '';
        });
        return $data;
    }

    public static function is_arrays_equal(array $a,array $b){
        if (array_diff($a, $b) == array_diff($b, $a)) {
            return true;
        }
        return false;
    }

    public static function is_set($var){
        if(!empty($var) && isset($var)){
            return true;
        }
        return false;
    }

    public static function avans_create_coupon(object $args){
        global $wpdb;

        $charachter = self::is_set($args->char) ? $args->char : 6;
        $prefix = self::is_set($args->prefix) ? $args->prefix : '';

        $status = false;
        do {
            $coupon_code = strtolower($prefix.wp_generate_password($charachter, false));
            $sql = $wpdb->prepare("SELECT ID FROM $wpdb->posts WHERE post_title = %s AND post_type = 'shop_coupon' AND post_status = 'publish' ORDER BY post_date DESC LIMIT 1;", $coupon_code);
            if (empty($wpdb->get_var($sql))) {
                $status = true;
                break;
            }
        } while (!$status);

        $coupon = array(
            'post_title'   => $coupon_code,
            'post_content' => '',
            'post_status'  => 'publish',
            'post_author'  => 1,
            'post_type'    => 'shop_coupon'
        );
        $couponid = wp_insert_post($coupon);
        
        if (self::is_set($args->include)) {
            update_post_meta($couponid, 'product_ids', $args->include);
        }

        if (self::is_set($args->exclude)) {
            update_post_meta($couponid, 'exclude_product_ids', $args->exclude);
        }

        if (self::is_set($args->type)) {
            update_post_meta($couponid, 'discount_type', $args->type);
        }

        if (self::is_set($args->amount)) {
            update_post_meta($couponid, 'coupon_amount', $args->amount);
        }

        if (self::is_set($args->expire)) {
            $expiry_date   =  date('Y-m-d', strtotime('+'.$args->expire.' days'));
            update_post_meta($couponid, 'expiry_date', $expiry_date);
        }

        if (self::is_set($args->include_cats)) {
            update_post_meta($couponid, 'product_categories', $args->include_cats);
        }

        if (self::is_set($args->exclude_cats)) {
            update_post_meta($couponid, 'exclude_product_categories', $args->exclude_cats);
        }
    
        if (self::is_set($args->email)) {
            update_post_meta($couponid, 'customer_email', $args->email);
        }

        if (self::is_set($args->min_amount)) {
            update_post_meta($couponid, 'minimum_amount', $args->min_amount);
        }

        if (self::is_set($args->max_amount)) {
            update_post_meta($couponid, 'maximum_amount', $args->max_amount);
        }

        if(self::is_set($args->max_discount)){
            update_post_meta($couponid, 'max_discount', $args->max_discount);
        }

         if(self::is_set($args->exclude_sale_products) && $args->exclude_sale_products){
            update_post_meta($couponid, 'exclude_sale_items', 'yes');
        }


        update_post_meta($couponid, 'individual_use', 'yes');
        update_post_meta($couponid, 'free_shipping', 'no');
        update_post_meta($couponid, 'usage_limit', '1');
        update_post_meta($couponid, 'apply_before_tax', 'yes');

        return $coupon_code;
    }

    public static function toEnNumber($input) {
        $replace_pairs = array(
            '۰' => '0', '۱' => '1', '۲' => '2', '۳' => '3', '۴' => '4', '۵' => '5', '۶' => '6', '۷' => '7', '۸' => '8', '۹' => '9',
            '٠' => '0', '١' => '1', '٢' => '2', '٣' => '3', '٤' => '4', '٥' => '5', '٦' => '6', '٧' => '7', '٨' => '8', '٩' => '9'
        );
        
        return strtr( $input, $replace_pairs );
    }


    public static function log($entry, $mode = 'a'){
        // Get WordPress uploads directory.
        $upload_dir = wp_upload_dir();
        $upload_dir = $upload_dir['basedir'];

        // If the entry is array, json_encode.
        if (is_array($entry) || is_object($entry)) {
            $entry = json_encode($entry);
        }

        // Write the log file.
        $file  = $upload_dir . '/avans.log';
        $file  = fopen($file, $mode);
        $bytes = fwrite($file, current_time('mysql') . "::" . $entry . "\n");
        fclose($file);

        return $bytes;
    }

    public static function avans_send_email($data, $path){
        ob_start();
        include $path;
        $html=ob_get_contents();
        ob_end_clean();

        foreach ($data as $index=>$var) {
            $html =  str_replace('{'.$index.'}', $var, $html);
        }

        $emailsite = get_bloginfo('admin_email');
        $site_name = get_bloginfo('name');

        $headers  = "From: $site_name < $emailsite >\n";
        // $headers .= "Cc: $site_name < $emailsite >\n";
        $headers .= "X-Sender: $site_name < $emailsite >\n";
        $headers .= 'X-Mailer: PHP/' . phpversion();
        $headers .= "X-Priority: 1\n";
        $headers .= "MIME-Version: 1.0\r\n";
        $headers .= "Content-Type: text/html; charset=utf-8\n";

        $result = wp_mail($data['email'], $data['title'], $html, $headers);

        return $result;
    }

    public static function avans_export_csv(array $header , array $rows){
        ob_start();
        $domain = $_SERVER['SERVER_NAME'];
        $filename = 'avans-users-' . $domain . '-' . time() . '.csv';
        $upload_dir = wp_upload_dir()['basedir'];
        $outPut = $upload_dir . '/avans-exports/';
        if(!file_exists($outPut)){
            wp_mkdir_p($outPut);
        }
        $file = @fopen($outPut.$filename, 'w');
        fprintf($file, chr(0xEF) . chr(0xBB) . chr(0xBF));
        header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
        header('Content-Description: File Transfer');
        header('Content-type: text/csv');
        header("Content-Disposition: attachment; filename={$filename}");
        header('Expires: 0');
        header('Pragma: public');
        fputcsv($file, $header);
        foreach ($rows as $row) {
            fputcsv($file, $row);
        }
        fclose($file);
        ob_end_flush();
        return wp_upload_dir()['baseurl']."/avans-exports/".$filename;
    }

}
