<?php namespace Avans\parts;

use Avans\triggers;

class badge extends triggers
{
    public function __construct()
    {
        $this->check_condition_for_get_badge();
    }

    public function check_condition_for_get_badge()
    {
        add_action('avans_after_purchase', array($this,'check_condition_for_badge_after_purchase'), 10, 2);
        add_action('avans_after_comment', array($this,'check_condition_for_badge_after_comment_accepted'), 10, 1);
        add_action('avans_after_gform_submitted', array($this,'check_condition_for_badge_after_gform_submitted'), 10, 3);
        add_action('avans_after_share_post', array($this,'check_condition_for_badge_after_share_post'), 10, 2);
        add_action('avans_after_publish_post', array($this,'check_condition_for_badge_after_publish_post'), 10, 2);
        add_action('avans_after_view_post_type', array($this,'check_condition_for_badge_after_view_post_type'), 10, 2);
        add_action('avans_after_view_video', array($this,'check_condition_for_badge_after_view_video'), 10, 4);
        add_action('avans_after_listen_podcasts', array($this,'check_condition_for_badge_after_listen_to_podcast'), 10, 4);
        add_action('avans_after_register_date_user', array($this,'check_condition_for_badge_after_register_date_user'), 10, 1);
        add_action('avans_after_referer_code_used_for_register', array($this,'check_condition_for_badge_after_referer_for_register_user'), 10, 3);
        add_action('avans_before_badge_details',array($this,'check_condition_for_badge_before_show_details_badge'), 10, 2);
        add_action('avans_after_change_score',array($this,'check_condition_for_badge_after_change_score'), 10, 5);
        add_action('avans_before_custom_course_enrolled',array($this,'check_condition_for_badge_after_course_enrolled'), 10, 2);
        add_action('avans_before_custom_course_completed',array($this,'check_condition_for_badge_after_course_completed'), 10, 2);
    }


    public static function get_badges()
    {
        $args = ['numberposts' => -1,'post_type'=> 'avans-badge'];
        return get_posts($args);
    }
     
    public static function get_badge_steps($id)
    {
        $option = get_post_meta($id, AVANS_PREFIX.'badge_settings', true);
        return $option['steps'];
    }
}
