<?php namespace Avans;

use Avans\parts\badge;
use stdClass;

class triggers
{
    public function check_condition_for_badge_after_purchase($order, $user)
    {
        $badges = badge::get_badges();
        foreach ($badges as $badge) {
            $data = new stdClass;
            $steps = badge::get_badge_steps($badge->ID);
            $data->ID = $badge->ID;
            foreach ($steps as $index => $step) {
                $data->index = $index;
                $data->step = $step;
                switch ($step->action) {
                    case 'value_of_total_purchase_products':
                    $this->check_value_of_total_purchase_products($user, $data);
                    break;
                    case 'custom_product_purchased':
                        $this->check_custom_product_purchased($user, $data);
                    break;
                    case 'total_products_purchased':
                        $this->check_total_products_purchased($user, $data);
                    break;
                    case 'total_order_up_to_custom_amount':
                        $this->check_total_order_up_to_custom_amount($order, $user, $data);
                    break;
                }
            }
            user::check_is_get_badge($user->ID, $steps, $badge->ID);
        }
    }


    public function check_total_products_purchased($user, $data){

        if (user::is_in_array_meta_step_badge($user, $data->ID, $data->index)) {
            return;
        }
        if (user::get_count_products_purchased($user->ID) >= $data->step->count) {
            user::add_meta_step_badge($user, $data->ID, $data->index);
        }

    }


    public function check_condition_for_badge_before_show_details_badge($user_id,$badge_id){
        $data = new stdClass;
        $steps = badge::get_badge_steps($badge_id);
        $data->ID = $badge_id;
        foreach ($steps as $index => $step) {
            $data->index = $index;
            $data->step = $step;
            switch ($step->action) {
                case 'custom_avans_badge_getted':
                $this->check_custom_avans_badge_getted(wp_get_current_user($user_id), $data);
                break;
            }
        }
        user::check_is_get_badge($user_id, $steps, $badge_id);
    }


    public function check_custom_avans_badge_getted($user,$data){
        if (user::is_in_array_meta_step_badge($user, $data->ID, $data->index)) {
             return;
        }
        if (in_array((int)$data->step->post_id ,user::get_badges_user($user->ID))) {
            user::add_meta_step_badge($user, $data->ID, $data->index);
        }
    }

    public function check_value_of_total_purchase_products($user, $data)
    {
        if (user::is_in_array_meta_step_badge($user, $data->ID, $data->index)) {
            return;
        }
        $total = user::get_customer_total_order($user);
        if ((int)$total >= (int)$data->step->total_purcahase) {
            user::add_meta_step_badge($user, $data->ID, $data->index);
        }
    }

    public function check_custom_product_purchased($user, $data)
    {
        if (user::is_in_array_meta_step_badge($user, $data->ID, $data->index)) {
            return;
        }
        if (wc_customer_bought_product(null, $user->ID, $data->step->product_id)) {
            user::add_meta_step_badge($user, $data->ID, $data->index);
        }
    }
  
    public function check_total_order_up_to_custom_amount($order, $user, $data)
    {
        if (user::is_in_array_meta_step_badge($user, $data->ID, $data->index)) {
            return;
        }
        $total = data::get_total_order($order);
        if ((int)$total >= (int)$data->step->total_order) {
            user::add_meta_step_badge($user, $data->ID, $data->index);
        }
    }

    public function check_condition_for_badge_after_course_enrolled($user_id, $course_id){

        $badges = badge::get_badges();
        foreach ($badges as $badge) {
            $data = new stdClass;
            $steps = badge::get_badge_steps($badge->ID);
            $data->ID = $badge->ID;
            foreach ($steps as $index => $step) {
                $data->index = $index;
                $data->step = $step;
                switch ($step->action) {
                    case 'custom_course_enrolled':
                    $this->check_custom_course_enrolled($user_id, $course_id, $data);
                    break;
                }
            }
            user::check_is_get_badge($user_id, $steps, $badge->ID);
        }

    }
    public function check_condition_for_badge_after_course_completed($user_id, $course_id){

        $badges = badge::get_badges();
        foreach ($badges as $badge) {
            $data = new stdClass;
            $steps = badge::get_badge_steps($badge->ID);
            $data->ID = $badge->ID;
            foreach ($steps as $index => $step) {
                $data->index = $index;
                $data->step = $step;
                switch ($step->action) {
                    case 'custom_course_completed':
                    $this->check_custom_course_completed($user_id, $course_id, $data);
                    break;
                }
            }
            user::check_is_get_badge($user_id, $steps, $badge->ID);
        }

    }


    public function check_custom_course_enrolled($user_id, $course_id, $data){
        $user = get_user_by('ID', $user_id);
        if (user::is_in_array_meta_step_badge($user, $data->ID, $data->index)) {
            return;
        }
        if ($course_id == $data->step->post_id) {
            user::add_meta_step_badge($user, $data->ID, $data->index);
        }
    }

    public function check_custom_course_completed($user_id, $course_id, $data){
        $user = get_user_by('ID', $user_id);
        if (user::is_in_array_meta_step_badge($user, $data->ID, $data->index)) {
            return;
        }
        if ($course_id == $data->step->post_id) {
            user::add_meta_step_badge($user, $data->ID, $data->index);
        }
    }
   
    public function check_condition_for_badge_after_comment_accepted($comment)
    {
        if ( (int)$comment->user_id == 0) {
            return;
        }

        $badges = badge::get_badges();
        foreach ($badges as $badge) {
            $data = new stdClass;
            $steps = badge::get_badge_steps($badge->ID);
            $data->ID = $badge->ID;
            foreach ($steps as $index => $step) {
                $data->index = $index;
                $data->step = $step;
                switch ($step->action) {
                    case 'customer_commented_in_custom_page':
                    $this->check_customer_commented_in_custom_page($comment, $data, $comment->user_id);
                    break;
                    case 'insert_a_comment_in_the_post':
                    $this->check_insert_a_comment_in_the_post($comment, $data, $comment->user_id);
                    break;
                    case 'total_comments_posted':
                    $this->check_total_comments_posted($data, $comment->user_id);
                    break;
                }
            }
            user::check_is_get_badge($comment->user_id, $steps, $badge->ID);
        }
    }

    public function check_total_comments_posted($data, $user_id){
        $user = get_user_by('ID', $user_id);
        if (user::is_in_array_meta_step_badge($user, $data->ID, $data->index)) {
            return;
        }
        if (user::get_count_comments_posted($user_id) >= $data->step->count) {
            user::add_meta_step_badge($user, $data->ID, $data->index);
        }
    }

    public function check_customer_commented_in_custom_page($comment, $data, $user_id)
    {
        $user = get_user_by('ID', $user_id);
        if (user::is_in_array_meta_step_badge($user, $data->ID, $data->index)) {
            return;
        }

        if (get_post_type($comment->comment_post_ID) == 'product' && wc_customer_bought_product(null, $user->ID, $comment->comment_post_ID)) {

            if ($comment->comment_post_ID == $data->step->product_id) {
                user::add_meta_step_badge($user, $data->ID, $data->index);
            }
        }
    }

    public function check_insert_a_comment_in_the_post($comment, $data, $user_id)
    {
        $user = get_user_by('ID', $user_id);
        if (user::is_in_array_meta_step_badge($user, $data->ID, $data->index)) {
            return;
        }
        if ($comment->comment_post_ID == $data->step->post_id) {
            user::add_meta_step_badge($user, $data->ID, $data->index);
        }
    }

    public function check_condition_for_badge_after_gform_submitted($user, $entry, $form)
    {
        $badges = badge::get_badges();
            foreach ($badges as $badge) {
                $data = new stdClass;
                $steps = badge::get_badge_steps($badge->ID);
                $data->ID = $badge->ID;
                foreach ($steps as $index => $step) {
                    $data->index = $index;
                    $data->step = $step;
                    switch ($step->action) {
                    case 'custom_gform_submitted':
                    $this->check_custom_gform_submitted($user, $entry, $data);
                    break;
                    case 'custom_gform_submitted_for_severaltimes':
                    $this->check_custom_gform_submitted_for_severaltimes($user, $entry, $data);
                    break;
                }
                user::check_is_get_badge($user->ID,$steps,$badge->ID);
            }
        }
    }


    public function check_custom_gform_submitted($user, $form, $data)
    {
        if (user::is_in_array_meta_step_badge($user, $data->ID, $data->index)) {
            return;
        }
        $gforms_submitted = (array)get_user_meta($user->ID, AVANS_PREFIX.'gform_submited', true);
        if (in_array($form['form_id'], $gforms_submitted)) {
            user::add_meta_step_badge($user, $data->ID, $data->index);
        }
    }

    public function check_custom_gform_submitted_for_severaltimes($user, $form, $data)
    {
        if (user::is_in_array_meta_step_badge($user, $data->ID, $data->index)) {
            return;
        }
        $gforms_submitted = (array)get_user_meta($user->ID, AVANS_PREFIX.'gform_submited', true);
        $gform_unique = array_count_values($gforms_submitted);

        if (in_array($form->ID, $gforms_submitted) && (int)$gform_unique[$form['form_id']] >= (int)$data->step->count) {
            user::add_meta_step_badge($user, $data->ID, $data->index);
        }
    }

    public function check_condition_for_badge_after_share_post($user, $post_id)
    {
        $badges = badge::get_badges();
        foreach ($badges as $badge) {
            $data = new stdClass;
            $steps = badge::get_badge_steps($badge->ID);
            $data->ID = $badge->ID;
            foreach ($steps as $index => $step) {
                $data->index = $index;
                $data->step = $step;
                switch ($step->action) {
                    case 'share_custom_post_with_a_number_of_people':
                    $this->check_share_custom_post_with_a_number_of_people($user, $post_id, $data);
                    break;
                }
            }
            user::check_is_get_badge($user->ID, $steps, $badge->ID);
        }
    }

    public function check_share_custom_post_with_a_number_of_people($user, $post_id, $data)
    {
        if (user::is_in_array_meta_step_badge($user, $data->ID, $data->index)) {
            return;
        }
        if ($post_id == $data->step->post_id) {
            user::add_meta_step_badge($user, $data->ID, $data->index);
        }
    }

    public function check_condition_for_badge_after_publish_post($post, $published)
    {
        $badges = badge::get_badges();
        foreach ($badges as $badge) {
            $data = new stdClass;
            $steps = badge::get_badge_steps($badge->ID);
            $data->ID = $badge->ID;
            foreach ($steps as $index => $step) {
                $data->index = $index;
                $data->step = $step;
                switch ($step->action) {
                    case 'insert_post_by_number':
                    $this->check_insert_post_by_number($post, $published, $data);
                    break;
                }
            }
            user::check_is_get_badge($post->post_author, $steps, $badge->ID);
        }
    }

    public function check_insert_post_by_number($post, $published, $data)
    {
        $user = get_user_by('ID', $post->post_author);
        if (user::is_in_array_meta_step_badge($user, $data->ID, $data->index)) {
            return;
        }
        if (count_user_posts($user->ID) >= $data->step->count) {
            user::add_meta_step_badge($user, $data->ID, $data->index);
        }
    }

    public function check_condition_for_badge_after_view_post_type($user_id, $post_id)
    {
        $badges = badge::get_badges();
        foreach ($badges as $badge) {
            $data = new stdClass;
            $steps = badge::get_badge_steps($badge->ID);
            $data->ID = $badge->ID;
            foreach ($steps as $index => $step) {
                $data->index = $index;
                $data->step = $step;
                switch ($step->action) {
                    case 'view_custom_post_type_by_number':
                    $this->check_view_custom_post_type_by_number($user_id, $post_id, $data);
                    break;
                }
            }
            user::check_is_get_badge($user_id, $steps, $badge->ID);
        }
    }

    public function check_view_custom_post_type_by_number($user_id, $post_id, $data)
    {
        $user = get_user_by('ID', $user_id);
        if (user::is_in_array_meta_step_badge($user, $data->ID, $data->index)) {
            return;
        }
        $posts = (array)get_user_meta($user_id, AVANS_PREFIX.$data->step->post_type.'_viewed', true);
        if (count($posts) >= $data->step->count) {
            user::add_meta_step_badge($user, $data->ID, $data->index);
        }
    }

    public function check_condition_for_badge_after_view_video($user, $player_id, $video_viewed, $post_id)
    {
        $badges = badge::get_badges();
        foreach ($badges as $badge) {
            $data = new stdClass;
            $steps = badge::get_badge_steps($badge->ID);
            $data->ID = $badge->ID;
            foreach ($steps as $index => $step) {
                $data->index = $index;
                $data->step = $step;
                switch ($step->action) {
                  case 'view_video_by_number':
                    $this->check_view_video_by_number($user, $video_viewed, $data);
                  break;
                  case 'view_custom_video_in_custom_page':
                    $this->check_view_custom_video_in_custom_page($user, $video_viewed, $data);
                  break;
              }
            }
            user::check_is_get_badge($user->ID, $steps, $badge->ID);
        }
    }


    public function check_view_video_by_number($user, $video_viewed, $data)
    {
        if (user::is_in_array_meta_step_badge($user, $data->ID, $data->index)) {
            return;
        }
        if (count($video_viewed) >= $data->step->count) {
            user::add_meta_step_badge($user, $data->ID, $data->index);
        }
    }


    public function check_view_custom_video_in_custom_page($user, $video_viewed, $data)
    {
        if (user::is_in_array_meta_step_badge($user, $data->ID, $data->index)) {
            return;
        }
        if (in_array($data->step->post_id.$data->step->video_id, $video_viewed)) {
            user::add_meta_step_badge($user, $data->ID, $data->index);
        }
    }


    public function check_condition_for_badge_after_listen_to_podcast($user, $player_id, $sound_viewed, $post_id)
    {
        $badges = badge::get_badges();
        foreach ($badges as $badge) {
            $data = new stdClass;
            $steps = badge::get_badge_steps($badge->ID);
            $data->ID = $badge->ID;
            foreach ($steps as $index => $step) {
                $data->index = $index;
                $data->step = $step;
                switch ($step->action) {
                  case 'listen_to_podcasts_by_number':
                    $this->check_listen_to_podcasts_by_number($user, $sound_viewed, $data);
                  break;
                  case 'listen_to_custom_podcast_in_custom_page':
                    $this->check_listen_to_custom_podcast_in_custom_page($user, $sound_viewed, $data);
                  break;
              }
            }
            user::check_is_get_badge($user->ID, $steps, $badge->ID);
        }
    }



    public function check_listen_to_podcasts_by_number($user, $sound_viewed, $data)
    {
        if (user::is_in_array_meta_step_badge($user, $data->ID, $data->index)) {
            return;
        }
        if (count($sound_viewed) >= $data->step->count) {
            user::add_meta_step_badge($user, $data->ID, $data->index);
        }
    }

   
    public function check_listen_to_custom_podcast_in_custom_page($user, $sound_viewed, $data)
    {
        if (user::is_in_array_meta_step_badge($user, $data->ID, $data->index)) {
            return;
        }
        if (in_array($data->step->post_id.$data->step->podcast_id, $sound_viewed)) {
            user::add_meta_step_badge($user, $data->ID, $data->index);
        }
    }

    public function check_condition_for_badge_after_register_date_user($user)
    {
        $badges = badge::get_badges();

        foreach ($badges as $badge) {
            $data = new stdClass;
            $steps = badge::get_badge_steps($badge->ID);
            $data->ID = $badge->ID;
            foreach ($steps as $index => $step) {
                $data->index = $index;
                $data->step = $step;
                switch ($step->action) {
                    case 'period_of_user_membership_time_to_custom_time':
                      $this->check_period_of_user_membership($user, $data);
                    break;
                }
            }
            user::check_is_get_badge($user->ID, $steps, $badge->ID);
        }
    }


    public function check_period_of_user_membership($user, $data)
    {   
        return $user;
        if (user::is_in_array_meta_step_badge($user, $data->ID, $data->index)) {
            return;
        }
        $unit = $data->step->unit;
        $time = $data->step->time;
        $userdata = get_userdata($user->ID);
        $registered = $userdata->user_registered;
        $unittime = func::covert_string_time_to_timestamp($unit);
        $differnce = func::diference_time_now_for_date_db($registered);
        if (($differnce/$unittime) >= $time) {
            user::add_meta_step_badge($user, $data->ID, $data->index);
        }
    }


    public function check_condition_for_badge_after_referer_for_register_user($referer, $user, $usersRefs)
    {
        $badges = badge::get_badges();
        foreach ($badges as $badge) {
            $data = new stdClass;
            $steps = badge::get_badge_steps($badge->ID);
            $data->ID = $badge->ID;
            foreach ($steps as $index => $step) {
                $data->index = $index;
                $data->step = $step;
                switch ($step->action) {
                    case 'register_new_users_with_ref_code_by_number':
                      $this->check_register_new_users_with_ref_code_by_number($referer, $user, $usersRefs, $data);
                    break;
                }
            }
            user::check_is_get_badge($referer->ID, $steps, $badge->ID);
        }
    }


    public function check_register_new_users_with_ref_code_by_number($referer, $user, $usersRefs, $data)
    {
        if (user::is_in_array_meta_step_badge($referer, $data->ID, $data->index)) {
            return;
        }
        if (count(func::get_array_without_empty($usersRefs)) >= $data->step->count) {
            user::add_meta_step_badge($referer, $data->ID, $data->index);
        }
    }


    public function check_condition_for_badge_after_change_score($type,$score,$total,$details,$user_id){
        $badges = badge::get_badges();
        foreach ($badges as $badge) {
            $data = new stdClass;
            $steps = badge::get_badge_steps($badge->ID);
            $data->ID = $badge->ID;
            foreach ($steps as $index => $step) {
                $data->index = $index;
                $data->step = $step;
                switch ($step->action) {
                    case 'custom_avans_score_getted':
                      $this->check_user_score( get_user_by('ID',$user_id) ,$data);
                    break;
                }
            }
            user::check_is_get_badge($user_id, $steps, $badge->ID);
        }
    }


    public function check_user_score($user,$data){
        if (user::is_in_array_meta_step_badge($user, $data->ID, $data->index)) {
            return;
        }
        if (user::get_score($user->ID) >= $data->step->count) {
            user::add_meta_step_badge($user, $data->ID, $data->index);
        }
    }





}
