<?php

use Avans\data;
use Avans\func;
use Avans\integrations;
use Avans\parts\badge;
use Avans\parts\referer;
use Avans\update;
use Avans\user;

function avans_save_score_setting_callback()
{
    if (!current_user_can('manage_avans_options')) {
        wp_send_json([
            'message' => "You do not have permission to access this section",
       ], 403);
    }

    $data = get_option('avans_plugin_setting', []);

    $settings = [];

    $settings['post'] = [];
    $settings['post']['active'] = $_POST['is_active_score_posts'] === 'true' ? true : false;
    $settings['post']['score'] = $_POST['value_score_view_post'];
    $settings['post']['delay'] = $_POST['delay_get_score_post'];
    $settings['post']['text'] = sanitize_text_field($_POST['text_toast_score_post']);
    $settings['post']['condition'] = $_POST['avans_condition_post'];
    $settings['post']['limit'] = ['value' => $_POST['value_max_scorring_for_posts'] , 'unit' => $_POST['unit_max_scorring_for_posts']];
    $settings['post']['expire'] = ['value' => $_POST['value_expire_score_for_posts'] , 'unit' => $_POST['unit_expire_score_for_posts']];

    $settings['course'] = [];
    $settings['course']['active'] = $_POST['is_active_score_course'] === 'true' ? true : false;
    $settings['course']['score'] = $_POST['value_score_view_course'];
    $settings['course']['delay'] = $_POST['delay_get_score_course'];
    $settings['course']['text'] = sanitize_text_field($_POST['text_toast_score_course']);
    $settings['course']['limit'] = ['value' => $_POST['value_max_scorring_for_course'] , 'unit' => $_POST['unit_max_scorring_for_course']];
    $settings['course']['expire'] = ['value' => $_POST['value_expire_score_for_course'] , 'unit' => $_POST['unit_expire_score_for_course']];
    $settings['course']['condition'] = $_POST['avans_condition_course'];

    

    $settings['course']['enroll_course'] = [];
    $settings['course']['enroll_course']['active'] = $_POST['is_active_score_enroll_course'] === 'true' ? true : false;
    $settings['course']['enroll_course']['score'] = $_POST['value_score_enroll_course'];
    $settings['course']['enroll_course']['limit'] = ['value' => $_POST['value_max_scorring_for_enroll_course'] , 'unit' => $_POST['unit_max_scorring_for_enroll_course']];
    $settings['course']['enroll_course']['expire'] = ['value' => $_POST['value_expire_score_for_enroll_course'] , 'unit' => $_POST['unit_expire_score_for_enroll_course']];
    $settings['course']['enroll_course']['condition'] = $_POST['avans_condition_enroll_course'];

    $settings['course']['complete_lesson'] = [];
    $settings['course']['complete_lesson']['active'] = $_POST['is_active_score_complete_lesson'] === 'true' ? true : false;
    $settings['course']['complete_lesson']['score'] = $_POST['value_score_complete_lesson'];
    $settings['course']['complete_lesson']['text'] = sanitize_text_field($_POST['text_toast_score_complete_lesson']);
    $settings['course']['complete_lesson']['limit'] = ['value' => $_POST['value_max_scorring_for_complete_lesson'] , 'unit' => $_POST['unit_max_scorring_for_complete_lesson']];
    $settings['course']['complete_lesson']['expire'] = ['value' => $_POST['value_expire_score_for_complete_lesson'] , 'unit' => $_POST['unit_expire_score_for_complete_lesson']];
    $settings['course']['complete_lesson']['condition'] = $_POST['avans_condition_complete_lesson'];

    $settings['course']['complete_course'] = [];
    $settings['course']['complete_course']['active'] = $_POST['is_active_score_complete_course'] === 'true' ? true : false;
    $settings['course']['complete_course']['score'] = $_POST['value_score_complete_course'];
    $settings['course']['complete_course']['text'] = sanitize_text_field($_POST['text_toast_score_complete_course']);
    $settings['course']['complete_course']['limit'] = ['value' => $_POST['value_max_scorring_for_complete_course'] , 'unit' => $_POST['unit_max_scorring_for_complete_course']];
    $settings['course']['complete_course']['expire'] = ['value' => $_POST['value_expire_score_for_complete_course'] , 'unit' => $_POST['unit_expire_score_for_complete_course']];
    $settings['course']['complete_course']['condition'] = $_POST['avans_condition_complete_course'];

    $settings['course']['passed_test'] = [];
    $settings['course']['passed_test']['active'] = $_POST['is_active_score_passed_test'] === 'true' ? true : false;
    $settings['course']['passed_test']['score'] = $_POST['value_score_passed_test'];
    $settings['course']['passed_test']['text'] = sanitize_text_field($_POST['text_toast_score_passed_test']);
    $settings['course']['passed_test']['limit'] = ['value' => $_POST['value_max_scorring_for_passed_test'] , 'unit' => $_POST['unit_max_scorring_for_passed_test']];
    $settings['course']['passed_test']['expire'] = ['value' => $_POST['value_expire_score_for_passed_test'] , 'unit' => $_POST['unit_expire_score_for_passed_test']];
    $settings['course']['passed_test']['condition'] = $_POST['avans_condition_passed_test'];

    $settings['product'] = [];
    $settings['product']['active'] = $_POST['is_active_score_products'] === 'true' ? true : false;
    $settings['product']['score'] = $_POST['value_score_view_product'];
    $settings['product']['delay'] = $_POST['delay_get_score_product'];
    $settings['product']['text'] = sanitize_text_field($_POST['text_toast_score_product']);
    $settings['product']['condition'] = $_POST['avans_condition_product'];
    $settings['product']['limit'] = ['value' => $_POST['value_max_scorring_for_products'] , 'unit' => $_POST['unit_max_scorring_for_products']];
    $settings['product']['expire'] = ['value' => $_POST['value_expire_score_for_products'] , 'unit' => $_POST['unit_expire_score_for_products']];


    $settings['purchase'] = [];
    $settings['purchase']['active'] = $_POST['is_active_score_purchase'] === 'true' ? true : false;
    $settings['purchase']['type'] = $_POST['type_model_scoring_prurchase'];
    $settings['purchase']['fix_score'] = $_POST['value_score_purchase'];
    $settings['purchase']['fix_score_product'] = $_POST['value_score_purchase_by_product'];
    $settings['purchase']['flex_unit'] = $_POST['value_price_unit_purchase'];
    $settings['purchase']['flex_score'] = $_POST['value_score_purchase_by_volume'];
    $settings['purchase']['min_price'] = $_POST['score_minimum_price_order'];
    $settings['purchase']['status'] = $_POST['order_status_for_score'];
    $settings['purchase']['text'] = sanitize_text_field($_POST['text_toast_score_purchase']);
    $settings['purchase']['condition'] = $_POST['avans_condition_purchase'];
    $settings['purchase']['limit'] = ['value' => $_POST['value_max_scorring_for_orders'] , 'unit' => $_POST['unit_max_scorring_for_orders']];
    $settings['purchase']['expire'] = ['value' => $_POST['value_expire_score_for_orders'] , 'unit' => $_POST['unit_expire_score_for_orders']];
    $settings['purchase']['single_text']['active'] =  $_POST['is_active_show_score_purchase_in_single_page'] === 'true' ? true : false;
    $settings['purchase']['single_text']['type'] = $_POST['type_model_show_scoring_prurchase_in_single_page'];
    $settings['purchase']['single_text']['text'] = $_POST['text_purchase_score_in_single_product'];
    $settings['purchase']['checkout_text']['active'] =  $_POST['is_active_show_score_purchase_in_checkout'] === 'true' ? true : false;
    $settings['purchase']['checkout_text']['text'] = $_POST['text_purchase_score_in_checkout'];


    $settings['comment'] = [];
    $settings['comment']['active'] = $_POST['is_active_score_comments'] === 'true' ? true : false;
    $settings['comment']['once_comment'] = $_POST['is_active_once_comment'] === 'true' ? true : false;
    $settings['comment']['score'] = $_POST['value_score_add_comment'];
    $settings['comment']['score_wc'] =  $_POST['value_score_add_comment_by_purchaser'];
    $settings['comment']['condition'] = $_POST['avans_condition_comment'];
    $settings['comment']['limit'] = ['value' => $_POST['value_max_scorring_for_comments'] , 'unit' => $_POST['unit_max_scorring_for_comments']];
    $settings['comment']['expire'] = ['value' => $_POST['value_expire_score_for_comments'] , 'unit' => $_POST['unit_expire_score_for_comments']];


    $settings['register'] = [];
    $settings['register']['active'] = $_POST['is_active_score_register'] === 'true' ? true : false;
    $settings['register']['score'] = $_POST['value_score_register'];
    $settings['register']['text'] =  sanitize_text_field($_POST['text_toast_score_register']);
    $settings['register']['expire'] = ['value' => $_POST['value_expire_score_for_user_register'] , 'unit' => $_POST['unit_expire_score_for_user_register']];

    $settings['ref-register']['active'] = $_POST['is_active_score_referer_register'] === 'true' ? true : false;
    $settings['ref-register']['score'] = $_POST['value_score_referer_register'];
    $settings['ref-register']['expire'] = ['value' => $_POST['value_expire_score_for_referer_register'] , 'unit' => $_POST['unit_expire_score_for_referer_register']];
    $settings['ref-register']['limit'] = ['value' => $_POST['value_max_scorring_for_referer_register'] , 'unit' => $_POST['unit_max_scorring_for_referer_register']];
    $settings['ref-register']['condition'] = $_POST['avans_condition_referer_register'];

    $settings['complete-profile'] = [];
    $settings['complete-profile']['active'] = $_POST['is_active_score_complete_profile'] === 'true' ? true : false;
    $settings['complete-profile']['score'] = $_POST['value_score_complete_profile'];
    $settings['complete-profile']['text'] =  sanitize_text_field($_POST['text_toast_score_complete_profile']);
    $settings['complete-profile']['expire'] = ['value' => $_POST['value_expire_score_for_complete_profile'] , 'unit' => $_POST['unit_expire_score_for_complete_profile']];
    $settings['complete-profile']['condition'] = $_POST['avans_condition_complete_profile'];

    $settings['daily'] = [];
    $settings['daily']['active'] = $_POST['is_active_score_daily_visit'] === 'true' ? true : false;
    $settings['daily']['score'] = $_POST['value_score_daily_visit'];
    $settings['daily']['delay'] =  $_POST['delay_get_score_daily_visit'];
    $settings['daily']['text'] =  sanitize_text_field($_POST['text_toast_score_daily_visit']);
    $settings['daily']['condition'] = $_POST['avans_condition_daily'];
    $settings['daily']['limit'] = ['value' => $_POST['value_max_scorring_for_daily_visit'] , 'unit' => $_POST['unit_max_scorring_for_daily_visit']];
    $settings['daily']['expire'] = ['value' => $_POST['value_expire_score_for_daily_visit'] , 'unit' => $_POST['unit_expire_score_for_daily_visit']];

    $settings['post-rating'] = [];
    $settings['post-rating']['active'] = $_POST['is_active_score_post_rating'] === 'true' ? true : false;
    $settings['post-rating']['score'] = $_POST['value_score_post_rating'];
    $settings['post-rating']['text'] =  sanitize_text_field($_POST['text_toast_score_post_rating']);
    $settings['post-rating']['condition'] = $_POST['avans_condition_post_rating'];
    $settings['post-rating']['limit'] = ['value' => $_POST['value_max_scorring_for_post_rating'] , 'unit' => $_POST['unit_max_scorring_for_post_rating']];
    $settings['post-rating']['expire'] = ['value' => $_POST['value_expire_score_for_post_rating'] , 'unit' => $_POST['unit_expire_score_for_post_rating']];

    $settings['share'] = [];
    $settings['share']['active'] = $_POST['is_active_score_share_link'] === 'true' ? true : false;
    $settings['share']['score'] = $_POST['value_score_share_link'];
    $settings['share']['delay'] =  $_POST['delay_get_score_share_link'];
    $settings['share']['condition'] = $_POST['avans_condition_share'];
    $settings['share']['limit'] = ['value' => $_POST['value_max_scorring_for_share'] , 'unit' => $_POST['unit_max_scorring_for_share']];
    $settings['share']['expire'] = ['value' => $_POST['value_expire_score_for_share'] , 'unit' => $_POST['unit_expire_score_for_share']];

    $settings['publish'] = [];
    $settings['publish']['active'] = $_POST['is_active_score_publish_post'] === 'true' ? true : false;
    $settings['publish']['score'] = $_POST['value_score_publish_post'];
    $settings['publish']['condition'] = $_POST['avans_condition_publish'];
    $settings['publish']['limit'] = ['value' => $_POST['value_max_scorring_for_publish'] , 'unit' => $_POST['unit_max_scorring_for_publish']];
    $settings['publish']['expire'] = ['value' => $_POST['value_expire_score_for_publish'] , 'unit' => $_POST['unit_expire_score_for_publish']];

    $settings['publish-product'] = [];
    $settings['publish-product']['active'] = $_POST['is_active_score_publish_product'] === 'true' ? true : false;
    $settings['publish-product']['score'] = $_POST['value_score_publish_product'];
    $settings['publish-product']['condition'] = $_POST['avans_condition_publish_product'];
    $settings['publish-product']['limit'] = ['value' => $_POST['value_max_scorring_for_publish_product'] , 'unit' => $_POST['unit_max_scorring_for_publish_product']];
    $settings['publish-product']['expire'] = ['value' => $_POST['value_expire_score_for_publish_product'] , 'unit' => $_POST['unit_expire_score_for_publish_product']];


    $settings['birthday'] = [];
    $settings['birthday']['active'] = $_POST['is_active_score_birthday'] === 'true' ? true : false;
    $settings['birthday']['editable'] = $_POST['is_active_show_birth_day_field_in_woopanel'] === 'true' ? true : false;
    $settings['birthday']['score'] = $_POST['value_score_score_birthday'];
    $settings['birthday']['condition'] = $_POST['avans_condition_birthday'];
    $settings['birthday']['expire'] = ['value' => $_POST['value_expire_score_for_birthday'] , 'unit' => $_POST['unit_expire_score_for_birthday']];

    $settings['registerday'] = [];
    $settings['registerday']['active'] = $_POST['is_active_score_registerd_date'] === 'true' ? true : false;
    $settings['registerday']['score'] = $_POST['value_score_registerd_date'];
    $settings['registerday']['condition'] = $_POST['avans_condition_registerday'];
    $settings['registerday']['expire'] = ['value' => $_POST['value_expire_score_for_registerday'] , 'unit' => $_POST['unit_expire_score_for_registerday']];

    // //other general
    // $data['ddo_score_position_toast'] = $_POST['ddo_score_position_toast'];
    // $data['score_users_blocked'] = $_POST['score_users_blocked'];
    $data['score_settings'] = $settings;
    update_option('avans_plugin_setting', $data);
    wp_send_json([
            'success' => true,
            'data' => $data
    ], 200);
}
add_action('wp_ajax_avans_save_score_setting', 'avans_save_score_setting_callback');


function avans_save_covert_score_setting_callback()
{
    if (!current_user_can('manage_avans_options')) {
        wp_send_json([
            'message' => "You do not have permission to access this section",
       ], 403);
    }

    $data = get_option('avans_plugin_setting', []);
    $settings = [];
    $settings['wallet']['active'] = $_POST['is_active_convert_wallet'] === 'true' ? true : false;
    $settings['wallet']['cost_unit'] = $_POST['cost_of_unit_score'];
    $settings['wallet']['min_score'] =  $_POST['minimum_score_for_convert_wallet'];
    $settings['wallet']['limit'] = ['value' => $_POST['value_max_convert_wallet'] , 'unit' => $_POST['unit_max_convert_wallet']];

    $data['convert_settings'] = $settings;
    update_option('avans_plugin_setting', $data);
    wp_send_json([
        'success' => true,
    ], 200);
}
add_action('wp_ajax_avans_save_covert_score_setting', 'avans_save_covert_score_setting_callback');


function avans_save_coupen_generate_setting_callback()
{
    if (!current_user_can('manage_avans_options')) {
        wp_send_json([
            'message' => "You do not have permission to access this section",
       ], 403);
    }

    $data = get_option('avans_plugin_setting', []);
    $settings = [];
    $coupons = $_POST['coupons'];
    foreach($coupons as $coupon){
        $settings[$coupon['event']] = $coupon;
    }

    $data['coupen_settings'] = $settings;
    update_option('avans_plugin_setting', $data);

    wp_send_json([
    'success' => true,
    ], 200);
}
add_action('wp_ajax_avans_save_coupen_generate_setting', 'avans_save_coupen_generate_setting_callback');


function avans_save_referal_code_setting_callback()
{
    if (!current_user_can('manage_avans_options')) {
        wp_send_json([
            'message' => "You do not have permission to access this section",
       ], 403);
    }

    $data = get_option('avans_plugin_setting', []);

    $settings = [];
    $settings['referer']['active'] = $_POST['is_active_score_referal_code'] === 'true' ? true : false;
    $settings['referer']['format'] = $_POST['format_code_referal'];
    $settings['referer']['format_suffix'] = $_POST['suffix_format_code_referal'];
    $settings['referer']['format_prefix'] = $_POST['prefix_format_code_referal'];
    $settings['referer']['repeat'] = $_POST['count_use_from_code_referal'];
    $settings['referer']['fee'] = $_POST['value_fee_referal_code'];
    $settings['referer']['fee_type'] = $_POST['value_fee_referal_code_type'];
    $settings['referer']['ref_gift'] = $_POST['value_score_referal_user'];
    $settings['referer']['ref_gift_type'] = $_POST['type_score_referal_user'];
    $settings['referer']['day_coocki'] = $_POST['value_day_referal_code_coocki'];
    $settings['referer']['condition-coupon'] = $_POST['avans_condition_referer_coupon'];
    $settings['referer']['condition-commission'] = $_POST['avans_condition_referer_commission'];

    $referer = AVANS_SETTINGS['referer_settings']['referer'];
    if ($_POST['format_code_referal'] !== $referer['format']) {
        $users = get_users();
        foreach ($users as $user):
        $userid = $user->ID;
        if ($_POST['format_code_referal'] == 'auto') {
            $referalID = chr(rand(97, 122)).rand('11', '99').$userid.chr(rand(97, 122)).rand('11', '99');
        } else {
            $referalID = $_POST['prefix_format_code_referal'].chr(rand(97, 122)).rand('11', '99').$userid.chr(rand(97, 122)).rand('11', '99').$_POST['suffix_format_code_referal'];
        }
        update_user_meta($userid, AVANS_PREFIX.'user_ref_code', $referalID);
        endforeach;
    }


    if ($_POST['format_code_referal'] === $referer['format'] && $_POST['format_code_referal'] === 'custom') {


        if ($_POST['prefix_format_code_referal'] !== $referer['format_prefix'] || $_POST['suffix_format_code_referal'] !== $referer['format_suffix']) {
            $users = get_users();
            foreach ($users as $user):
                $userid = $user->ID;
                $referalID = $_POST['prefix_format_code_referal'].chr(rand(97, 122)).rand('11', '99').$userid.chr(rand(97, 122)).rand('11', '99').$_POST['suffix_format_code_referal'];
                update_user_meta($userid, AVANS_PREFIX.'user_ref_code', $referalID);
            endforeach;
        }
    }

    $data['referer_settings'] = $settings;
    update_option('avans_plugin_setting', $data);
    wp_send_json([
        'success' => true,
        'data' => $data
    ], 200);
}
add_action('wp_ajax_avans_save_referal_code_setting', 'avans_save_referal_code_setting_callback');

function avans_score_general_settings_callback()
{
    if (!current_user_can('manage_avans_options')) {
        wp_send_json([
            'message' => "You do not have permission to access this section",
       ], 403);
    }

    $data = get_option('avans_plugin_setting', []);

    $settings = [];
    $service = $_POST['sms_service'];
    $settings['sms']['service'] = $service;
    $settings['sms']['username_'.$service] = trim($_POST['sms_username']);
    $settings['sms']['password_'.$service] = trim($_POST['sms_password']);
    $settings['sms']['api_'.$service] = trim( $_POST['sms_api']);
    $settings['sms']['sender_'.$service] = trim($_POST['sms_sender']);
    $settings['score']['icon'] = trim($_POST['score_icon']);
    $settings['score']['label'] = trim($_POST['score_label']);
    $settings['notification']['position'] = $_POST['notif_position'];
    $settings['notification']['time'] = $_POST['notif_time'];
    $settings['notification']['sound'] = $_POST['notif_sound'];
    $settings['notification']['icon'] = $_POST['notif_icon'];
    $settings['notification']['background'] = $_POST['notif_background'];
    $settings['notification']['text_color'] = $_POST['notif_color_text'];
    $settings['notification']['border_color'] = $_POST['notif_color_border'];
    $settings['notification']['background'] = $_POST['notif_background'];
    $settings['permision']['users'] = $_POST['user_not_permision'];
    $settings['permision']['roles'] = $_POST['role_not_permision'];

    $settings['decrease_method'] = $_POST['status_main_score_after_convert'];
    
    $data['general_settings'] = $settings;
    update_option('avans_plugin_setting', $data);
    wp_send_json([
        'success' => true,
        'data' => $data,
    ], 200);
}
add_action('wp_ajax_avans_score_general_settings', 'avans_score_general_settings_callback');

function avans_user_panel_settings_callback(){

    if (!current_user_can('manage_avans_options')) {
        wp_send_json([
            'message' => "You do not have permission to access this section",
       ], 403);
    }

    $data = get_option('avans_plugin_setting', []);

    $data['panel_settings'] = $_POST['settings'];
    update_option('avans_plugin_setting', $data);
    wp_send_json([
        'success' => true,
        'data' => $data,
    ], 200);

}
add_action('wp_ajax_avans_user_panel_settings', 'avans_user_panel_settings_callback');


function avans_get_data_condition_callback()
{
    $type = $_GET['type'];
    if ($type == 'role') {
        global $wp_roles;
        $roles = apply_filters('editable_roles', $wp_roles->roles);
        foreach ($roles as $index=>$rol) {
            ?>
            <option value="<?php echo $index ?>" ><?php echo translate_user_role($rol['name']) ?></option>
            <?php
        }
    }

    if ($type == 'level') {
        $data = get_option('avans_plugin_setting', []);
        foreach ((array)$data['avans_user_levels'] as $level) :
        ?>
            <option value="<?php echo $level['level'] ?>" ><?php echo $level['level'] ?></option>
        <?php
        endforeach;
    }


    if($type == 'badge'){
        $badges = badge::get_badges();
        foreach ((array) $badges as $badge) :
        ?>
            <option value="<?php echo $badge->ID ?>" ><?php echo get_the_title($badge->ID) ?></option>
        <?php
        endforeach;
    }

    die;
}
add_action('wp_ajax_avans_get_data_condition', 'avans_get_data_condition_callback');



function avans_userlevels_setting_callback()
{
    if (!current_user_can('manage_avans_options')) {
        wp_send_json([
            'message' => "You do not have permission to access this section",
       ], 403);
    }


    $data = get_option('avans_plugin_setting', []);
    $data['avans_user_levels'] = $_POST['levels'];
    update_option('avans_plugin_setting', $data);
    wp_send_json([
        'success' => true,
    ]);
}
add_action('wp_ajax_avans_userlevels_setting', 'avans_userlevels_setting_callback');


function avans_serach_user_callback()
{
    $return = array();
    $search_string = esc_attr(trim($_GET['q']));
    $args = array(
        'search' => "*{$search_string}*",
        'search_columns' => array(
            'user_login',
            'user_nicename',
            'user_email',
            'user_url',
        ),
    );

    $user_query = new WP_User_Query($args);
    if (!empty($user_query->results)) {
        foreach ($user_query->results as $index=>$user) {
            $return[] = array($user->ID,$user->display_name);
        }
    }
    echo json_encode($return);
    die;
}
add_action('wp_ajax_avans_serach_user', 'avans_serach_user_callback');

function avans_search_logs_callback(){
    $args = [];

    if(func::is_set($_GET['type']) || func::is_set($_GET['user']) || func::is_set($_GET['from']) || func::is_set($_GET['to']) ){
        $args['where'] = true;
    }
    if (isset($_GET['type']) && !empty($_GET['type'])) {
        $args['include']['type'] = $_GET['type'];
    }
    if (isset($_GET['user']) && !empty($_GET['user'])) {
        $args['include']['user'] = $_GET['user'];
    }
    if (isset($_GET['from']) && !empty($_GET['from'])) {
        $args['time']['from'] = Avans\func::convert_jalali_to_miladi($_GET['from']);
    }
    if (isset($_GET['to']) && !empty($_GET['to'])) {
        $args['time']['to'] = Avans\func::convert_jalali_to_miladi($_GET['to']);
    }
    if(isset($_GET['page']) && !empty($_GET['page'])){
        $args['page'] = $_GET['page'];
    }

    $logs = Avans\data::get_logs($args);
    include AVANS_PATH.'templates/admin/settings/log/parts/main/main.php';

    die;
}
add_action('wp_ajax_avans_search_logs','avans_search_logs_callback');

function avans_search_ref_logs_callback()
{
        $args = [];
    if (func::is_set($_GET['user']) || func::is_set($_GET['from']) || func::is_set($_GET['to'])) {
        $args['where'] = true;
    }
    if (func::is_set($_GET['user'])) {
        $args['include']['user'] = $_GET['user'];
    }
    if (func::is_set($_GET['from'])) {
        $args['time']['from'] = func::convert_jalali_to_miladi($_GET['from']);
    }
    if (func::is_set($_GET['to'])) {
        $args['time']['to'] = func::convert_jalali_to_miladi($_GET['to']);
    }
    if (func::is_set($_GET['page'])) {
        $args['page'] = $_GET['page'];
    }

    $logs = Avans\data::get_logs_refs($args);
    include AVANS_PATH.'templates/admin/settings/refs-log/parts/main/main.php';

}

add_action('wp_ajax_avans_search_ref_logs', 'avans_search_ref_logs_callback');


function avans_search_gifts_logs_callback(){
    $args = [];
    if (func::is_set($_GET['gift']) || func::is_set($_GET['user']) || func::is_set($_GET['from']) || func::is_set($_GET['to'])) {
        $args['where'] = true;
    }

    if(func::is_set($_GET['gift']) && $_GET['gift'] != 0){
        $args['include']['gift'] = $_GET['gift'];
    }
    if (func::is_set($_GET['user'])) {
        $args['include']['user'] = $_GET['user'];
    }
    if (func::is_set($_GET['from'])) {
        $args['time']['from'] = func::convert_jalali_to_miladi($_GET['from']);
    }
    if (func::is_set($_GET['to'])) {
        $args['time']['to'] = func::convert_jalali_to_miladi($_GET['to']);
    }
    if (func::is_set($_GET['page'])) {
        $args['page'] = $_GET['page'];
    }

    $logs = Avans\data::get_logs_gifts($args);
    include AVANS_PATH.'templates/admin/settings/gifts-log/parts/main/main.php';
    die;
}
add_action('wp_ajax_avans_search_gifts_logs','avans_search_gifts_logs_callback');

function avans_get_result_gift_callback(){
    if (!current_user_can('manage_avans_gifts')) {
       wp_send_json([
            'message' => "You do not have permission to access this section",
       ],403);
    }
    $gift_id = $_GET['id'];
    $option = [];
    if((int)$gift_id > 0){
        $option = (array)get_post_meta((int)$gift_id, AVANS_PREFIX.'gift_settings', true);
    }
    $data = $_GET['content'];
    $created_at = $_GET['created_at'];
    if(!isset($option['avans_type_gift'])){
        $option['avans_type_gift'] = data::get_type_gifts(json_encode($_GET['content']))['type'];
    }

    if ($data) {
        include_once AVANS_PATH.'templates/front/panel/content/sections/gift-results.php';
    }     
    die;
}
add_action("wp_ajax_avans_get_result_gift","avans_get_result_gift_callback");

function avans_search_users_callback()
{
    $args = [];

    if (isset($_GET['type']) && !empty($_GET['type'])) {
        $args['type'] = $_GET['type'];
    }
    if (isset($_GET['user']) && !empty($_GET['user'])) {
        $args['user'] = $_GET['user'];
    }
    if (isset($_GET['from']) && !empty($_GET['from'])) {
        $args['time']['from'] = Avans\func::convert_jalali_to_miladi($_GET['from']);
    }
    if (isset($_GET['to']) && !empty($_GET['to'])) {
        $args['time']['to'] = Avans\func::convert_jalali_to_miladi($_GET['to']);
    }
    
    if(func::is_set($_GET['user']) || func::is_set($_GET['type']) || func::is_set($_GET['from']) || func::is_set($_GET['to']) ){
        $args['where'] = true;
    }

    if (isset($_GET['page']) && !empty($_GET['page'])) {
        $args['page'] = $_GET['page'];
    }

    $users = Avans\data::get_users($args);
    include AVANS_PATH.'templates/admin/settings/users/parts/main/main.php';

    die;
}
add_action('wp_ajax_avans_search_users', 'avans_search_users_callback');

function avans_search_in_users_callback(){
    $return = array();

    $args = array(
        'order' => 'DESC',
        'search' => '*'.esc_attr(trim($_GET['q'])).'*',
        'search_columns' => array( 'user_login', 'user_login', 'user_nicename', 'user_email'),
    );


    $users = get_users($args);
    if (!empty($users)) {
        foreach ($users as $index=>$user) {
            $name = $user->display_name .' :: '. $user->user_login;
            $return[] = array($user->ID,$name);
        }
    }
    echo json_encode($return);
    die;
}
add_action('wp_ajax_avans_search_in_users', 'avans_search_in_users_callback');

function avans_serach_course_callback(){
    $return = array();
    $search_string = esc_attr(trim($_GET['q']));

    $post_types = get_post_types( '', 'names' ); 
    if(!is_array($post_types)){
        die;
    }

    $post_types_valid = array();

    foreach(data::get_lms_postTypes_support() as $course_post_type){
        if(in_array($course_post_type , $post_types)){
            $post_types_valid[] = $course_post_type;
        }
    }

    $args = array(
        'post_type' => $post_types_valid,
        'orderby' => 'title',
        'order' => 'ASC',
        'numberposts' => 200,
        'post_status' => array('publish'),
        's' => $search_string,
    );

    $posts = get_posts($args);
    if (!empty($posts)) {
        foreach ($posts as $index=>$post) {
            $return[] = array($post->ID,$post->post_title);
        }
    }
    // echo json_encode($posts);
    echo json_encode($return);
    die;
}
add_action("wp_ajax_avans_serach_course","avans_serach_course_callback");

function avans_serach_product_callback(){
    $return = array();
    $search_string = esc_attr(trim($_GET['q']));
    $args = array(
        'post_type' => array('product','product_variation'),
        'orderby' => 'title',
        'order' => 'ASC',
        'numberposts' => 200,
        's' => $search_string,
    );

    $posts = wc_get_products($args);
    if (!empty($posts)) {
        foreach ($posts as $index=>$post) {
            if ($post->get_type() == 'variable') {
                $product = wc_get_product($post->get_id());
                $childs = $product->get_children();
                foreach ($childs as $child) {
                    $product = wc_get_product($child);
                    $prTitle= str_replace('<span class="description">', '', $product->get_formatted_name());
                    $prTitle= str_replace('</span>', '', $prTitle);
                    $return[] = array($child,$prTitle);
                }
            } else {
                $return[] = array($post->get_ID(),$post->get_name());
            }
        }
    }

    // echo json_encode($posts);
    echo json_encode($return);
    die;
}
add_action('wp_ajax_avans_serach_product','avans_serach_product_callback');


function avans_serach_gform_callback()
{
    $return = array();
    $search_string = esc_attr(trim($_GET['q']));
    global $wpdb;
    $table_name = $wpdb->prefix.'gf_form';
    $forms = $wpdb->get_results("SELECT * FROM {$table_name} WHERE title LIKE '%$search_string%'");

    if (!empty($forms)) {
        foreach ($forms as $index=>$form) {
            $return[] = array($form->id,$form->title);
        }
    }
    // echo json_encode($posts);
    echo json_encode($return);
    die;
}
add_action('wp_ajax_avans_serach_gform', 'avans_serach_gform_callback');


function avans_serach_badges_callback(){
    $return = array();
    $search_string = esc_attr(trim($_GET['q']));
    $args = array(
        'post_type' => array('avans-badge'),
        'orderby' => 'title',
        'order' => 'ASC',
        'numberposts' => 200,
        'post_status' => array('publish'),
        's' => $search_string,
    );

    $posts = get_posts($args);
    if (!empty($posts)) {
        foreach ($posts as $index=>$post) {
            $return[] = array($post->ID,$post->post_title);
        }
    }
    // echo json_encode($posts);
    echo json_encode($return);
    die;

}
add_action('wp_ajax_avans_serach_badges','avans_serach_badges_callback');


function avans_serach_posts_callback(){
  $return = array();
    $search_string = esc_attr(trim($_GET['q']));
    $args = array(
        'post_type' => array('post','page'),
        'orderby' => 'title',
        'order' => 'ASC',
        'numberposts' => 200,
        'post_status' => array('publish'),
        's' => $search_string,
    );

    $posts = get_posts($args);
    if (!empty($posts)) {
        foreach ($posts as $index=>$post) {
            $return[] = array($post->ID,$post->post_title);
        }
    }
    // echo json_encode($posts);
    echo json_encode($return);
    die;

}
add_action('wp_ajax_avans_serach_posts','avans_serach_posts_callback');


function avans_serach_all_posts_callback(){
    $return = array();
    $search_string = esc_attr(trim($_GET['q']));
    $args = array(
        'post_type' => array('post','page','product'),
        'orderby' => 'title',
        'order' => 'ASC',
        'numberposts' => 200,
        'post_status' => array('publish'),
        's' => $search_string,
    );

    $posts = get_posts($args);
    if (!empty($posts)) {
        foreach ($posts as $index=>$post) {
            $return[] = array($post->ID,$post->post_title.' ('.$post->post_type.') ');
        }
    }
    // echo json_encode($posts);
    echo json_encode($return);
    die;

}
add_action('wp_ajax_avans_serach_all_posts','avans_serach_all_posts_callback');


function avans_serach_category_callback(){
    $return = array();
    $search_string = esc_attr(trim($_GET['q']));

    $args = array(
        // 'name__like' => $search_string,
        'taxonomy' => 'product_cat',
        'search' => $search_string,
    );

    $terms = get_terms($args);

    if (!empty($terms)) {
        foreach ($terms as $index=>$term) {
            $return[] = array($term->term_id,$term->name);
        }
    }

    // echo json_encode($posts);
    echo json_encode($return);
    die;

}
add_action('wp_ajax_avans_serach_category','avans_serach_category_callback');

function avans_increase_score_user_callback()
{
    if (!current_user_can('manage_avans_users')) {
        wp_send_json([
            'message' => "You do not have permission to access this section",
       ], 403);
    }

    $score = (int)$_POST['score'];
    $userid = (int)$_POST['userid'];
    $title = $_POST['title'];
    $expire = array(
        'value' => $_POST['expire_value'],
        'unit' => $_POST['expire_unit'],
    );
        
    $details = array(
        array(
            'key' => 'title',
            'value' =>  $title,
        )
    );

    if ($score != 0) {
        Avans\user::add_log($userid,'admin',$details,$score,$expire);
        wp_send_json([
        'success' => true,
        'score' => Avans\user::get_score($userid),
        'score_valid' => Avans\user::get_score_valid($userid),
        ], 200);
    }
}
add_action('wp_ajax_avans_increase_score_user', 'avans_increase_score_user_callback');


function avans_increase_score_users_callback(){

    if (!current_user_can('manage_avans_users')) {
        wp_send_json([
            'message' => "You do not have permission to access this section",
       ],403);
    }

    $score = (int)$_POST['score'];
    $title = $_POST['title'];

    $expire = array(
        'value' => $_POST['expire_value'],
        'unit' => $_POST['expire_unit'],
    );

    $details = array(
        array(
            'key' => 'title',
            'value' =>  $title,
        )
    );

    if ($score != 0) {

        $users = get_users();

        foreach($users as $user){
            user::add_log($user->ID, 'admin', $details, $score,$expire);
        }

        wp_send_json([
        'success' => true,
        ], 200);

    }

}
add_action("wp_ajax_avans_increase_score_users","avans_increase_score_users_callback");



function view_lottery_members_callback(){
    $members = Avans\parts\lottery::get_lottery_members($_GET['lottery_id']);
    include_once AVANS_PATH.'templates/admin/posttypes/lottery/get_members.php';
}
add_action('wp_ajax_view_lottery_members','view_lottery_members_callback');


function avans_run_lottery_callback(){
    if (!current_user_can('manage_avans_lottery')) {
        wp_send_json([
            'message' => "You do not have permission to access this section",
       ],403);
    }
    $winners = Avans\parts\lottery::do_lottery($_GET['lottery_id']);
    include_once AVANS_PATH.'templates/admin/posttypes/lottery/get_winners.php';
}
add_action('wp_ajax_avnas_run_lottery','avans_run_lottery_callback');





function avans_get_winners_lottery_callback(){
    if (!current_user_can('manage_avans_lottery')) {
        wp_send_json([
            'message' => "You do not have permission to access this section",
       ], 403);
    }

    $winners = Avans\parts\lottery::get_winners($_GET['lottery_id']);
    include_once AVANS_PATH.'templates/admin/posttypes/lottery/get_winners.php';
}
add_action('wp_ajax_avans_get_winners','avans_get_winners_lottery_callback');

function avans_get_trigger_badge_item_settings_callback(){
    include_once AVANS_PATH.'templates/admin/parts/badge_step.php';
    die;
}
add_action('wp_ajax_avans_get_trigger_badge_item_settings','avans_get_trigger_badge_item_settings_callback');



function avans_get_trigger_settings_fields_callback(){
    $type = $_GET['type'];
    include_once AVANS_PATH.'templates/admin/parts/badge_step_fields.php';
    die;
}
add_action('wp_ajax_avans_get_trigger_settings_fields','avans_get_trigger_settings_fields_callback');


function apply_commision_ref_order_callback(){
    if (!current_user_can('manage_avans_refs_logs')) {
       wp_send_json([
            'message' => "You do not have permission to access this section",
       ],403);
    }

    $status = referer::apply_commision_ref_order($_POST['log']);

    wp_send_json([
        'success' => $status,
    ]);
}
add_action('wp_ajax_apply_commision_ref_order','apply_commision_ref_order_callback');


function award_badges_to_user_callback(){

    if (!current_user_can('manage_avans_users')) {
        wp_send_json([
            'message' => "You do not have permission to access this section",
       ], 403);
    }

    $usersId = $_POST['user'];
    $badgeIDs = $_POST['badges'];

    foreach((array)$badgeIDs as $badgeID){
        user::add_badge_to_badges_user($usersId,$badgeID);
    }

    wp_send_json([
        'badges' => $badgeIDs,
        'user' => $usersId,
    ]);

}
add_action('wp_ajax_award_badges_to_user',"award_badges_to_user_callback");


function avans_add_step_or_badge_to_user_callback(){

    if (!current_user_can('manage_avans_users')) {
        wp_send_json([
            'message' => "You do not have permission to access this section",
       ], 403);
    }

    $usersId = $_POST['users'];
    $stepsIDs = $_POST['steps'];
    $badgeID = $_POST['badge'];
    $type = $_POST['type'];

    foreach( (array)$usersId as $user ){

        $stepsAll = badge::get_badge_steps($badgeID);

        $badge = (array)get_user_meta($user, AVANS_PREFIX.'step_badge_'.$badgeID, true);
        $badge = func::get_array_without_empty($badge);
        $stepschecked = array_unique($badge);


        func::log(array(
            'stepsall' => $stepsAll,
            'stepchecked' => $stepschecked,
        ));



        if(func::is_set($stepsIDs)){
            
            foreach((array)$stepsIDs as $step){


                if(!in_array((int)$step,$stepschecked) && $type == 'add'){
                    array_push($stepschecked, (int)$step);
                } 

                if(in_array((int)$step,$stepschecked) && $type == 'remove'){
                    foreach($stepschecked as $index => $item){
                        if($item == $step){
                            unset($stepschecked[$index]);
                        }
                    }
                }


            }
            
        }else{
            
            foreach((array)$stepsAll as $index => $step){

                if(!in_array((int)$index,$stepschecked) && $type == 'add'){
                    array_push($stepschecked, (int)$index);
                } 

                if($type == 'remove'){
                    $stepschecked = [];
                }

            }
            
        }

        update_user_meta($user, AVANS_PREFIX.'step_badge_'.$badgeID, $stepschecked);

        if($type == "add"){
            user::check_is_get_badge($user , $stepsAll, $badgeID );
        }else{
            user::remove_badge_user($user,$badgeID);
        }

    }

    wp_send_json([
        'steps' => $stepsIDs,
        'badge' => $badgeID,
        'user' => $user,
    ]);

}
add_action("wp_ajax_avans_add_step_or_badge_to_user","avans_add_step_or_badge_to_user_callback");



function update_options_last_version()
{
    if (!current_user_can('manage_options')) {
       wp_send_json([
            'message' => "You do not have permission to access this section",
       ],403);
    }

    ini_set('max_execution_time', 0);
    update::update_options();
    ini_set('max_execution_time', 300);
}
add_action('wp_ajax_update_options_last_version', 'update_options_last_version');


function update_users_meta_last_version()
{

    if (!current_user_can('manage_options')) {
       wp_send_json([
            'message' => "You do not have permission to access this section",
       ],403);
    }

    ini_set('max_execution_time', 0);
    update::update_all_users_meta();
    ini_set('max_execution_time', 300);
}
add_action('wp_ajax_update_users_meta_last_version', 'update_users_meta_last_version');


function update_pages_meta_last_version()
{

    if (!current_user_can('manage_options')) {
       wp_send_json([
            'message' => "You do not have permission to access this section",
       ],403);
    }

    ini_set('max_execution_time', 0);
    update::update_page_meta();
    ini_set('max_execution_time', 300);
}
add_action('wp_ajax_update_pages_meta_last_version', 'update_pages_meta_last_version');


function update_gifts_meta_last_version()
{

    if (!current_user_can('manage_options')) {
       wp_send_json([
            'message' => "You do not have permission to access this section",
       ],403);
    }

    ini_set('max_execution_time', 0);
    update::update_gift_meta();
    ini_set('max_execution_time', 300);
}
add_action('wp_ajax_update_gifts_meta_last_version', 'update_gifts_meta_last_version');


function update_orders_meta_last_version()
{

    if (!current_user_can('manage_options')) {
       wp_send_json([
            'message' => "You do not have permission to access this section",
       ],403);
    }

    ini_set('max_execution_time', 0);
    update::update_order_meta();
    ini_set('max_execution_time', 300);
}
add_action('wp_ajax_update_orders_meta_last_version', 'update_orders_meta_last_version');


function update_gifts_db_last_version()
{

    if (!current_user_can('manage_options')) {
       wp_send_json([
            'message' => "You do not have permission to access this section",
       ],403);
    }

    ini_set('max_execution_time', 0);
    update::gift_table_update();
    ini_set('max_execution_time', 300);
}
add_action('wp_ajax_update_gifts_db_last_version', 'update_gifts_db_last_version');

function update_logs_db_last_version()
{
    if (!current_user_can('manage_options')) {
       wp_send_json([
            'message' => "You do not have permission to access this section",
       ],403);
    }

    ini_set('max_execution_time', 0);
    update::score_table_update();
    ini_set('max_execution_time', 300);
}
add_action('wp_ajax_update_logs_db_last_version', 'update_logs_db_last_version');


function avans_set_clear_user_logs(){

    if (!current_user_can('manage_avans_options')) {
       wp_send_json([
            'message' => "You do not have permission to access this section",
       ],403);
    }

    global $wpdb;
    $table_log_score = $wpdb->prefix . user::$table_log;
    $wpdb->query("TRUNCATE TABLE $table_log_score");

    $table_log_meta = $wpdb->prefix . user::$tabel_log_meta;
    $wpdb->query("TRUNCATE TABLE $table_log_meta");
    
}
add_action('wp_ajax_avans_set_clear_user_logs', 'avans_set_clear_user_logs');


function avans_reset_expirable_actions_callback(){

    if (!current_user_can('manage_options')) {
       wp_send_json([
            'message' => "You do not have permission to access this section",
       ],403);
    }

    global $wpdb;
    $tbl = $wpdb->prefix.user::$table_log;
    $wpdb->query("UPDATE $tbl SET expire_date = NULL WHERE expire_date IS NOT NULL");

    $users = get_users();
    foreach ($users as $user):
        update_user_meta($user->ID, AVANS_PREFIX.'balance_score', 0);
    endforeach;

}
add_action("wp_ajax_avans_reset_expirable_actions" , "avans_reset_expirable_actions_callback");


function avans_set_zero_user_score(){

    if (!current_user_can('manage_options')) {
       wp_send_json([
            'message' => "You do not have permission to access this section",
       ],403);
    }

    $users = get_users();
    foreach ($users as $user):
        update_user_meta($user->ID, AVANS_PREFIX.'user_score', 0);
        update_user_meta($user->ID, AVANS_PREFIX.'user_score_valid', 0);
    endforeach;
}
add_action('wp_ajax_avans_set_zero_user_score', 'avans_set_zero_user_score');

function avans_import_score_form_some_plugins(){
    if (!current_user_can('manage_avans_options')) {
       wp_send_json([
            'message' => "You do not have permission to access this section",
       ],403);
    }

    $type = $_POST['type'];

    ini_set('max_execution_time', 0);
    integrations::import_score($type);
    ini_set('max_execution_time', 300);
}
add_action('wp_ajax_avans_import_score_form_some_plugins','avans_import_score_form_some_plugins');

function avans_export_users_data_callback()
{
    if (!current_user_can('manage_options')) {
        wp_send_json([
            'message' => "You do not have permission to access this section",
       ], 403);
    }

    $users = get_users( [
        'meta_key' => AVANS_PREFIX.'user_score',
        'orderby' => 'meta_value_num',
        'order' => 'DESC',
    ]);
    $header = [
        'ردیف',
        'نام کاربری',
        'نام نمایشی',
        'امتیاز کل کاربر',
        'امتیاز معتبر کاربر'
    ];
    $rows = [];
    foreach ($users as $index => $user){
        $rows[] = [
            $index + 1,
            $user->user_login,
            $user->display_name,
            user::get_score((int)$user->ID),
            user::get_score_valid((int)$user->ID),
        ];
    }

    $file_url = func::avans_export_csv($header,$rows);

    wp_send_json([
        'url' => $file_url,
    ]);
}
add_action('wp_ajax_avans_export_users_data', 'avans_export_users_data_callback');


function avans_export_logs_callback()
{
    if (!current_user_can('manage_avans_options')) {
        wp_send_json([
            'message' => "You do not have permission to access this section",
       ], 403);
    }

    $logs = data::get_logs(['per_page'=> 100000]);
    $header = [
        'شناسه',
        'نام کاربری',
        'نام نمایشی',
        'عنوان فعالیت',
        'نوع فعالیت',
        'امتیاز فعالیت',
        'جمع امتیازات بعد از فعالیت',
        'زمان انجام فعالیت'
    ];
    $rows = [];
    foreach ((array)$logs['result'] as $log) {
        $user = get_user_by('ID', $log->user);  
        $rows[] = [
            $log->id,
            $user->user_login,
            $user->display_name,
            data::get_log_title($log->type, Avans\data::get_meta_single_log($log->id)),
            $log->type,
            $log->score,
            $log->total,
            get_option('timezone_string') == 'Asia/Tehran' ? avans_date('Y/m/d h:i:s', strtotime($log->created_at), '', 'GMT') :  date('Y/m/d h:i:s', strtotime($log->created_at))
        ];
    }

    $file_url = func::avans_export_csv($header, $rows);

    wp_send_json([
        'url' => $file_url,
    ]);
}
add_action('wp_ajax_avans_export_logs', 'avans_export_logs_callback');


function avans_export_users_info_callback(){
    $option = $_POST['select'];
    $users = get_users();
    $rows = [];
    $header = $_POST['header'];
    foreach($users as $user){
        $data = user::export_users_info($user->ID,$option);
        $rows[] = $data;
    }
    $file_url = func::avans_export_csv($header, $rows);
    wp_send_json([
        'url' => $file_url,
    ]);
}
add_action("wp_ajax_avans_export_users_info","avans_export_users_info_callback");



function avans_update_user_ref_code_callback(){

    if (!current_user_can('manage_avans_users')) {
        wp_send_json([
            'message' => "You do not have permission to access this section",
       ], 403);
    }


    $userId = $_POST['user_id'];
    $refCode = $_POST['ref_code'];

    $referers = get_users(array('meta_key' =>  AVANS_PREFIX.'user_ref_code' , 'meta_value' => $refCode));

    if(count($referers) > 0){
        wp_send_json([
            'success' => false,
        ]);
    }

    update_user_meta($userId,AVANS_PREFIX.'user_ref_code',$refCode);
    wp_send_json([
        'user_id' => $userId,
        'display_name' => get_user_by('ID',$userId)->display_name,
        'success' => true,
    ]);


}
add_action("wp_ajax_avans_update_user_ref_code","avans_update_user_ref_code_callback");

function avans_get_list_badges_user_callback(){
    
    $userID = $_GET['userId'];
    $badges = user::get_badges_user($userID);
    $ajax = admin_url('admin-ajax.php');
    if(count($badges) > 0): ?>
        <div>نشان های دریافت شده</div>
        <hr>
        <?php foreach($badges as $badge):?>
            <li><?php echo get_the_title($badge) ?> <span class="removing-text"></span> <span data-user-id="<?php echo $userID; ?>" data-ajax-url="<?php echo $ajax; ?>" data-badge-id="<?php echo $badge; ?>" class="dashicons dashicons-no-alt"></span></li>
        <?php endforeach;
    endif;
    die();

}
add_action("wp_ajax_avans_get_list_badges_user","avans_get_list_badges_user_callback");

function avans_remove_custom_user_badge_callback(){
    $badge_id = $_POST['badge_id'];
    $user_id = $_POST['user_id'];
    user::remove_badge_user($user_id,$badge_id);
    wp_send_json([
        'success' => true,
    ]);
}
add_action("wp_ajax_avans_remove_custom_user_badge","avans_remove_custom_user_badge_callback");