<?php

use Avans\data;

$avs_coupon = $data['coupen_settings'][$event_type];
$avs_general_settings = $data['general_settings'];
$limited_custom_product_for_copon = [];

if(isset($avs_coupon['limit_products'])):
    foreach ((array)$avs_coupon['limit_products'] as $product) {
        $product = wc_get_product($product);
        if(is_object($product)){
            if ($product->get_type() == 'variation') {
                $prTitle= str_replace('<span class="description">', '', $product->get_formatted_name());
                $prTitle= str_replace('</span>', '', $prTitle);
                $item = [
                    'id' => $product->get_ID(),
                    'name' => $prTitle,
                ];
            } else {
                $item = [
                    'id' => $product->get_ID(),
                    'name' => get_the_title($product->get_ID()),
                ];
            }
            $limited_custom_product_for_copon[] = $item;
        }
    }
endif;

$limited_custom_category_for_copon = [];

if(isset($avs_coupon['limit_cats'])):
    foreach ((array)$avs_coupon['limit_cats'] as $cat) {
        $term_title = get_term($cat, 'product_cat');
        $item = [
            'id' => $cat,
            'name' => $term_title->name,
        ];
        $limited_custom_category_for_copon[] = $item;
    }
endif;

$exclude_custom_product_for_copon = [];

if(isset($avs_coupon['exclude_products'])):
    foreach ((array)$avs_coupon['exclude_products'] as $product) {
        $product = wc_get_product($product);
        if(is_object($product)){
            if ($product->get_type() == 'variation') {
                $prTitle= str_replace('<span class="description">', '', $product->get_formatted_name());
                $prTitle= str_replace('</span>', '', $prTitle);
                $item = [
                    'id' => $product->get_ID(),
                    'name' => $prTitle,
                ];
            } else {
                $item = [
                    'id' => $product->get_ID(),
                    'name' => get_the_title($product->get_ID()),
                ];
            }
            $exclude_custom_product_for_copon[] = $item;
        }
    }
endif;

$exclude_custom_category_for_copon = [];

if(isset($avs_coupon['exclude_cats'])):
    foreach ((array)$avs_coupon['exclude_cats'] as $cat) {
        $term_title = get_term($cat, 'product_cat');
        $item = [
            'id' => $cat,
            'name' => $term_title->name,
        ];
        $exclude_custom_category_for_copon[] = $item;
    }
endif;

?>
<div class="avans_coupon_events" data-content="<?php echo $event_type ?>">
    <table class="form-table">
            <tr valign="top">
                <th scope="row">فعال یا غیر فعال بودن این بخش</th>
                <td>
                    <label class="switch">
                        <input type="checkbox" class="is_active_generation_coupen" <?php echo $avs_coupon['active'] == 'true' ? 'checked' : '' ?> >
                        <span class="slider round"></span>
                        <span class="label">فعال/غیرفعال</span>
                    </label>
                </td>
            </tr>

            <tr valign="top">
                <th scope="row">میزان کد تخفیف</th>
                <td>
                <input type="number" class="value_percent_coupen" name="value_percent_coupen" value="<?php echo isset($avs_coupon['value']) ? $avs_coupon['value'] : '' ?>">
                <select class="avans_type_coupon_after_order">
                    <option value="percent" <?php echo empty($avs_coupon['type']) || $avs_coupon['type'] == 'percent' ? 'selected' : '' ?> >درصد</option>
                    <option value="static" <?php echo empty($avs_coupon['type']) || $avs_coupon['type'] == 'static' ? 'selected' : '' ?> ><?php echo data::get_payment_unit().'(ثابت)' ?></option>
                </select>
                </td>
            </tr>

            <tr valign="top">
                <th scope="row">سقف اعمال کد تخفیف</th>
                <td>
                <input type="number" class="max_discount_coupon" name="max_discount_coupon" value="<?php echo isset($avs_coupon['max_discount']) ? $avs_coupon['max_discount'] : '' ?>">
                <span><?php echo data::get_payment_unit() ?></span>
                </td>
            </tr>

            <tr valign="top">
                <th scope="row">تعداد کارکتر های (پویا) کدتخفیف</th>
                <td>
                <input type="number" class="number_of_charecter_coupen" name="number_of_charecter_coupen" value="<?php echo isset($avs_coupon['num_char']) ? $avs_coupon['num_char'] : '' ?>">
                    <label>کارکتر</label>
                </td>
            </tr>

            <tr valign="top">
                <th scope="row">پیشوند کد تخفیف</th>
                <td>
                    <input type="text" class="prefix_coupen" name="prefix_coupen" value="<?php echo isset($avs_coupon['prefix']) ? $avs_coupon['prefix'] : '' ?>">
                </td>
            </tr>

            <tr valign="top">
                <th scope="row">تاریخ انقضا کد</th>
                <td>
                <input type="number" class="expire_date_coupen" name="expire_date_coupen" value="<?php echo isset($avs_coupon['expire']) ? $avs_coupon['expire'] : '' ?>">
                <label>روز بعد از ارسال کد</label>
                </td>
            </tr>

            <tr valign="top">
                <th scope="row">به‌جز محصولات فروش ویژه</th>
                <td>
                    <label class="switch">
                        <input type="checkbox" class="is_active_exclude_sale_product_from_coupon" <?php echo $avs_coupon['exclude_sale_product'] == 'true' ? 'checked' : '' ?> >
                        <span class="slider round"></span>
                        <span class="label">فعال/غیرفعال</span>
                    </label>
                    <p>اگر نمی خواهید کد تخفیف برای محصولات تخفیف خورده استفاده شود، این بخش را فعال کنید</p>
                </td>
            </tr>

    </table>
    <div class="avans_accordion_box">
        <div class="accordion_title"><span>تعیین حداقل و حداکثر مبلغ سبد خرید برای اعمال کد</span><span class="dashicons dashicons-arrow-down-alt2"></span></div>
        <div class="accordion_wrapper">
            <table class="form-table">
                <tr valign="top">
                    <th scope="row">حداقل مبلغ سبد خرید برای اعمال کد</th>
                    <td>
                    <input type="number" class="min_price_for_coupen" name="min_price_for_coupen" value="<?php echo isset($avs_coupon['min_amount']) ? $avs_coupon['min_amount'] : '' ?>">
                    <span><?php echo data::get_payment_unit() ?></span>
                    </td>
                </tr>

                <tr valign="top">
                    <th scope="row">حداکثر مبلغ سبد خرید برای اعمال کد</th>
                    <td>
                    <input type="number" class="max_price_for_coupen" value="<?php echo isset($avs_coupon['max_amount']) ? $avs_coupon['max_amount'] : '' ?>">
                    <span><?php echo data::get_payment_unit() ?></span>
                    </td>
                </tr>
            </table>
        </div>
    </div>
    <div class="avans_accordion_box">
        <div class="accordion_title"><span>محدود کردن اعمال کد برای دسته بندی ها و محصولات خاص</span><span class="dashicons dashicons-arrow-down-alt2"></span></div>
        <div class="accordion_wrapper">
            <table class="form-table">
                <tr valign="top">
                    <th scope="row">اعمال بر محصولات خاص</th>
                    <td>
                        <label class="user">
                            <select class="limited_custom_product_for_copon" name="limited_custom_product_for_copon[]" data-avans="<?php echo htmlspecialchars(json_encode($limited_custom_product_for_copon), ENT_QUOTES, 'UTF-8') ?>"  data-placeholder="جستجو در بین محصولات..." multiple="multiple"></select>
                        </label>
                    </td>
                </tr>

                <tr valign="top">
                    <th scope="row">اعمال بر دسته بندی های خاص</th>
                    <td>
                    <label class="user">
                        <select class="limited_custom_category_for_copon" data-avans="<?php echo htmlspecialchars(json_encode($limited_custom_category_for_copon), ENT_QUOTES, 'UTF-8') ?>" data-placeholder="جستجو در بین دسته بندی ها..." multiple="multiple"></select>
                    </label>
                    </td>
                </tr>

                <tr valign="top">
                    <th scope="row">اعمال بجزء محصولات خاص</th>
                    <td>
                        <label class="user">
                            <select class="exclude_custom_product_for_copon" data-avans="<?php echo htmlspecialchars(json_encode($exclude_custom_product_for_copon), ENT_QUOTES, 'UTF-8') ?>"  data-placeholder="جستجو در بین محصولات..." multiple="multiple"></select>
                        </label>
                    </td>
                </tr>

                <tr valign="top">
                    <th scope="row">اعمال بجزء دسته بندی خاص</th>
                    <td>
                    <label class="user">
                        <select class="exclude_custom_category_for_copon" data-avans="<?php echo htmlspecialchars(json_encode($exclude_custom_category_for_copon), ENT_QUOTES, 'UTF-8') ?>" data-placeholder="جستجو در بین دسته بندی ها..." multiple="multiple"></select>
                    </label>
                    </td>
                </tr>
            </table>
        </div>
    </div>

    <?php if($event_type == 'after-order'): ?>
        <hr>
        <table class="form-table">
            <h2>شرایط ارسال کد تخفیف بعد از خرید</h2>

            <tr valign="top">
                <th scope="row">مبلغ سفارش</th>
                <td>
                    <label>اگر مبلغ هر سفارش بالای</label>  
                    <input type="number" class="minimum_total_price_for_send_cuppen" name="minimum_total_price_for_send_cuppen" value="<?php echo isset($avs_coupon['min_price'])? $avs_coupon['min_price'] : '' ?>">
                    <label> <?php echo function_exists('get_woocommerce_currency_symbol') ? get_woocommerce_currency_symbol(get_option('woocommerce_currency')) : 'تومان' ?> بود کد تخفیف ارسال شود!</label>
                </td>
            </tr>

            <tr valign="top">
                <th scope="row">حجم خرید</th>
                <td>
                    <label>اگر مجموع خریدهای کاربر از سایت به بالای</label>  
                    <input type="number" class="minimum_total_orders_for_send_cuppen" name="minimum_total_orders_for_send_cuppen" value="<?php echo isset($avs_coupon['min_orders'])? $avs_coupon['min_orders'] : '' ?>">
                    <label> <?php echo function_exists('get_woocommerce_currency_symbol') ? get_woocommerce_currency_symbol(get_option('woocommerce_currency')) : 'تومان' ?> رسید کد تخفیف ارسال شود!</label>
                </td>
            </tr>

            <tr valign="top">
                <th scope="row">دفعات ارسال برای هر کاربر</th>
                <td>
                    <input type="radio" name="is_send_cuppen_time_for_user" value="always" <?php echo ($avs_coupon['repeat']=='always') ? 'checked' : '' ?> > 
                    <label>همیشه</label>  
                    <input type="radio" name="is_send_cuppen_time_for_user" value="once" <?php echo ($avs_coupon['repeat']=='once' || empty($avs_coupon['repeat'])) ? 'checked' : '' ?>>
                    <label>فقط یکبار</label>
                </td>
            </tr>

            <tr valign="top">
                <th scope="row">فاصله زمانی تا ارسال بعد</th>
                <td>
                    <input type="number" class="value_limit_send_coupon_by_time" name="value_limit_send_coupon_by_time" value="<?php echo isset($avs_coupon['limit_time_value'])? $avs_coupon['limit_time_value'] : '' ?>">
                    <select class="unit_limit_send_coupon_by_time">
                        <option value="min" <?php echo  !isset($avs_coupon['limit_time_unit']) || $avs_coupon['limit_time_unit'] == 'min' ? 'selected' : '' ?> >دقیقه</option>
                        <option value="hour" <?php echo  $avs_coupon['limit_time_unit'] == 'hour' ? 'selected' : '' ?> >ساعت</option>
                        <option value="day" <?php echo  $avs_coupon['limit_time_unit'] == 'day' ? 'selected' : '' ?> >روز</option>
                        <option value="week" <?php echo  $avs_coupon['limit_time_unit'] == 'week' ? 'selected' : '';?> >هفته</option>
                        <option value="month" <?php echo  $avs_coupon['limit_time_unit'] == 'month' ? 'selected' : '' ?> >ماه</option>
                        <option value="year" <?php echo  $avs_coupon['limit_time_unit'] == 'year' ? 'selected' : '' ?> >سال</option>
                    </select>
                </td>
            </tr>

            <tr valign="top">
                <th scope="row">ارسال پیامک به مهمان</th>
                <td>
                    <label class="switch">
                        <input type="checkbox" class="is_active_send_coupon_for_guests" <?php echo $avs_coupon['guest_user'] == 'true' ? 'checked' : '' ?> >
                        <span class="slider round"></span>
                        <span class="label">فعال/غیرفعال</span>
                    </label>
                    <p>اگر می خواهید پیامک برای خریدارانی که ثبت نام نکرده اند یا وارد حساب کاربری خود نشده اند هم ارسال شود این گزینه را فعال کنید (در این حالت فقط مبلغ سفارش از شرایط فوق مورد بررسی قرار میگیرد و از سایر موارد صرف نظر میشود.)</p>
                </td>
            </tr>

        </table>
    <?php endif; ?>
    <hr>

    <?php
    if (data::check_smspanel_pattern_support($avs_general_settings['sms']['service'])) {
        include AVANS_PATH.'templates/admin/settings/index/parts/coupen-settings/sections/sms-events/pattern-support/sms.php';
    }else{
        include AVANS_PATH.'templates/admin/settings/index/parts/coupen-settings/sections/sms-events/text-support/sms.php';
    }
    ?>
</div>