
<?php
wp_enqueue_style('avans_select2');
?>

<label class="user">
    <span class="label">فیلتر کاربر</span>
    <select class="avans_search_user_select" data-placeholder="جستجو در بین کاربران..."></select>
</label>

<label class="action">
    <span class="label">فیلتر فعالیت</span>
        <?php include_once AVANS_PATH.'templates/generals/actions-list-select.php' ?>
    </select>
</label>

<label class="date">
    <span class="label">فیلتر تاریخ شروع گزارش</span>
    <input type="text" id="filter_time1" class="avans_persian_date_picker" placeholder="از تاریخ..." >
</label>

<label class="date">
    <span class="label">فیلتر تاریخ پایان گزارش</span>
    <input type="text" id="filter_time2" class="avans_persian_date_picker" placeholder="تا تاریخ...">
</label class="label">

<label class="btn-filter">
    <button id="avans-btn-filter-log" class="button">فیلتر کن!</button>
</label>

<script>
    jQuery(document).ready(function($){
        $('#checkselect2').select2();

        $('.avans_search_user_select').select2({
            ajax: {
                    url: '<?php echo admin_url('admin-ajax.php') ?>', // AJAX URL is predefined in WordPress admin
                    dataType: 'json',
                    delay: 250, 
                    data: function (params) {
                        return {
                            q: params.term,
                            action: 'avans_serach_user'
                        };
                    },
                    processResults: function( data ) {
                        var options = [];
                        if ( data ) {

                            // data is the array of arrays, and each of them contains ID and the Label of the option
                            $.each( data, function( index, text ) { // do not forget that "index" is just auto incremented value
                                options.push( { id: text[0], text: text[1]  } );
                            });

                        }
                        return {
                            results: options
                        }
                    },
                cache: true
            },
            minimumInputLength: 3,
            language: {
                inputTooShort: function () {
                    return "حداقل سه حرف از نام کاربری ، نام نمایشی یا ایمیل کاربر وارد نمایید...";
                },
                searching: function() {
                    return "در حال جستجو...";
                }
            }
        });
        var customOptions = {
			twodigit: false
			, closeAfterSelect: true
            // , nextButtonIcon : 'dashicons dashicons-arrow-left-alt2'
            // , previousButtonIcon : 'dashicons dashicons-arrow-right-alt2'
			// , buttonsColor: "blue"
			, forceFarsiDigits: true
			, markToday: true
			// , markHolidays: true
			, highlightSelectedDay: true
			, sync: true
			// , gotoToday: true
		}

        $("#avans-btn-filter-log").on('click', function (e) {
        e.preventDefault();
        // console.log(search);
            var data = {
                from: $(this).closest(".avs-header").find("#filter_time1").val(),
                to : $(this).closest(".avs-header").find("#filter_time2").val(),
                user : $(this).closest(".avs-header").find(".avans_search_user_select").val(),
                type : $(this).closest(".avs-header").find("#checkselect2").val(),
                page : 1,
            }
            search_logs(data);
        });

        $(document).on('click','a.page-numbers',function(e){
            e.preventDefault();
            var href = $(this).attr('href');
            var number = $(this).attr('href').split('cpage=');
            var data = {
                from: $('#avans-btn-filter-log').closest(".avs-header").find("#filter_time1").val(),
                to : $('#avans-btn-filter-log').closest(".avs-header").find("#filter_time2").val(),
                user : $('#avans-btn-filter-log').closest(".avs-header").find(".avans_search_user_select").val(),
                type : $('#avans-btn-filter-log').closest(".avs-header").find("#checkselect2").val(),
                page : number[1],
            }
            search_logs(data);
        });

        function search_logs(data){
            // console.log(data);
            $('.avans_log_wrapper')
            .append(
                '<div class="avans-loader"><div class="lds-ripple"><div></div><div></div></div></div>'
            );
            $.ajax({
                url : '<?php echo admin_url('admin-ajax.php') ?>',
                dataType : 'html',
                type: "GET",
                data : {
                    action : 'avans_search_logs',
                    from: data.from,
                    to : data.to,
                    user : data.user,
                    type : data.type,
                    page : data.page,
                },
                success:function(data){
                    // console.log(data);
                    $('.avans_log_wrapper>.avs-content').html(data);
                    $('.avans-loader').remove();
                }
            });
        }

    });
</script>

<?php
wp_enqueue_script('avans_select2');