<?php

use Avans\data;
use Avans\front;
use Avans\user;


if (get_current_user_id() == 0) {
    return;
}

global $wp;

include AVANS_PATH.'templates/front/panel/content/sections/settings.php';
?>

<?php if($settings->show_badges): ?>
    <div class="avans-user-root-item full badges" data-href="">
        <i class="avans-ic avs-icon-medal-solid"></i>
        <div class="root-item-main">
            <a class="item-title"><h4><?php echo $settings->title_badges ?></h4></a>
            <p class="item-description"><?php echo $settings->sub_title_badges ?></p>
            <?php echo do_shortcode('[avans-user-badges]'); ?>
        </div> 
    </div>
<?php endif; ?>



<div class="avans-user-root-wrapper" data-ajax="<?php echo admin_url('admin-ajax.php') ?>">

    <?php if($settings->show_gift): ?>
        <div class="avans-user-root-item half" data-page="gifts" data-href="<?php echo add_query_arg('avans_page','gifts') ?>">
            <div class="root-item-bg-icon"><i class="avans-ic avs-icon-gifts-solid"></i></div>
            <div class="root-item-main">
                <a class="item-title"><h4><?php echo $settings->title_gift ?></h4></a>
                <p class="item-description"><?php echo $settings->sub_title_gift ?></p>
                <a><i class="avans-ic avs-icon-left-open"></i></a>
            </div>        
        </div>
    <?php endif; ?>

    <?php if($settings->show_score_logs): ?>
    <div class="avans-user-root-item half"  data-page="reports" data-href="<?php echo add_query_arg('avans_page','reports') ?>">
        <div class="root-item-bg-icon"><i class="avans-ic avs-icon-list"></i></div>
        <div class="root-item-main">
            <a class="item-title"><h4><?php echo $settings->title_score_logs ?></h4></a>
            <p class="item-description"><?php echo $settings->sub_title_score_logs ?></p>
            <a><i class="avans-ic avs-icon-left-open"></i></a>
        </div>        
    </div>
    <?php endif; ?>

    <?php if($settings->show_convert_wallet): ?>
    <div class="avans-user-root-item half" data-page="convert" data-href="<?php echo add_query_arg('avans_page','convert') ?>">
        <div class="root-item-bg-icon"><i class="avans-ic avs-icon-exchange"></i></div>
        <div class="root-item-main">
            <a class="item-title"><h4><?php echo $settings->title_convert_wallet ?></h4></a>
            <p class="item-description"><?php echo $settings->sub_title_convert_wallet ?></p>
            <a><i class="avans-ic avs-icon-left-open"></i></a>
        </div>        
    </div>
    <?php endif; ?>

    <?php if($settings->show_referers): ?>
    <div class="avans-user-root-item half" data-page="referers" data-href="<?php echo add_query_arg('avans_page','referers') ?>">
        <div class="root-item-bg-icon"><i class="avans-ic avs-icon-dollar-1"></i></div>
        <div class="root-item-main">
            <a class="item-title"><h4><?php echo $settings->title_referers ?></h4></a>
            <p class="item-description"><?php echo $settings->sub_title_referers ?></p>
            <a><i class="avans-ic avs-icon-left-open"></i></a>
        </div>        
    </div>
    <?php endif; ?>

    <?php if($settings->show_lottery): ?>
    <div class="avans-user-root-item full" data-page="lottery" data-href="<?php echo $avs_panel['link_lottery'] ?>" >
        <div class="root-item-bg-icon"><i class="avans-ic avs-icon-dice-solid"></i></div>
        <div class="root-item-main">
            <a class="item-title"><h4><?php echo $settings->title_lottery ?></h4></a>
            <p class="item-description"><?php echo $settings->sub_title_lottery ?></p>
            <p class="avans_countdown_lottery"></p>
            <a><i class="avans-ic avs-icon-arrow-left"></i></a>
        </div>        
    </div>
    <?php 
    $data_group = explode(' ', $avs_panel['countdown_lottery']);
    $date = Avans\func::convert_jalali_to_miladi($data_group[0]);
    $date_seconds = isset($data_group[1]) ? explode(':', $data_group[1]) : '';
    $whatch = isset($data_group[1]) ? avans_tr_num($date_seconds[0]) .':'. avans_tr_num($date_seconds[1])  : '00:00:00';
    if(is_array($date)){
        $date = $date[0].'/'.$date[1].'/'.$date[2];
    }
    $date_format = $date.' '.$whatch;
    ?>
    <script defer>
        jQuery(document).ready(function($){
            var countDownDate = new Date("<?php echo $date_format ?>").getTime();
            new get_lottery_countdown_timer(countDownDate);
        });
    </script>
    <?php endif; ?>

    <?php if($settings->show_faq): ?> 
    <div class="avans-user-root-item full how-earn-score" data-page="faq" data-href="<?php echo $avs_panel['link_faq'] ?>">
        <div class="root-item-bg-icon"><i class="avans-ic avs-icon-help"></i></div>
        <div class="root-item-main">
            <a class="item-title"><h4><?php echo $settings->title_faq ?></h4></a>
        </div>        
    </div>
    <?php endif; ?>

    <?php if($settings->show_mission): ?>
    <div class="avans-user-root-item full missions" data-page="missions" data-href="">
        <div class="root-item-bg-icon"><i class="avans-ic avs-icon-dice-solid"></i></div>
        <div class="root-item-main">
            <a class="item-title" href=""></a><h4><?php echo $settings->title_mission ?></h4></a>
            <p class="item-description"><?php echo $settings->sub_title_mission  ?></p>
            <div class="items">
                <?php if($settings->show_spin_wheel): ?>
                <a href="<?php echo $avs_panel['link_spin_wheel'] ?>" class="spinwheel"><i class="avans-ic avs-icon-dharmachakra-solid"></i>بازی گردونه شانس</a>
                <?php endif; ?>
                <?php if($settings->show_complete_profile): ?>
                <a href="<?php echo add_query_arg('avans_page','complete_user_info') ?>" class="complete_profiles"><i class="avans-ic avs-icon-user-check-solid"></i>تکمیل پروفایل کاربری</a>
                <?php endif; ?>
            </div> 
            <!-- <a><i class="avans-ic avs-icon-arrow-left"></i></a> -->
        </div>        
    </div>
    <?php endif; ?>

</div>