<?php

use Avans\func;

    $complete = false;
    $fname    = $order->get_billing_first_name();
    $lname    = $order->get_billing_last_name();
    $state    = $order->get_billing_state();
    $city     = $order->get_billing_city();
    $address  = $order->get_billing_address_1();
    $postcode = $order->get_billing_postcode();
    $phone    = $order->get_billing_phone();

    if( func::is_set($fname) && 
        func::is_set($lname) && 
        func::is_set($state) &&
        func::is_set($city) && 
        func::is_set($address) && 
        func::is_set($postcode) && 
        func::is_set($phone) 
    ){
        $complete = true;
    }
?>

<div class="avans-shipping-info" style="<?php echo !$complete ? 'display:none' : '' ?>">
    <div class="title_and_edit">
        <p class="title-shipping-info">اطلاعات دریافت کننده جایزه</p>
        <button id="avans_edit_shipping_info">ویرایش</button>
    </div>
    <hr>
    <ul>
        <li><strong>نام</strong><span class="name"><?php echo $fname ?></span></li>
        <li><strong>نام خانوادگی</strong><span class="lastname"><?php echo $lname ?></span></li>
        <li><strong>استان</strong><span class="state"><?php echo $state ?></span></li>
        <li><strong>شهرستان</strong><span class="city"><?php echo $city ?></span></li>
        <li><strong>آدرس</strong><span class="address"><?php echo $address ?></span></li>
        <li><strong>کد پستی</strong><span class="zipcode"><?php echo $postcode ?></span></li>
        <li><strong>شماره موبایل</strong><span class="mobile"><?php echo $phone ?></span></li>
    </ul>
</div>

<div class="avans-shipping-form" style="<?php echo $complete ? 'display:none' : '' ?>" >

    <?php if(!$complete): ?>
        <div class="avans_error_shipping">برای دریافت جایزه نیاز هست اطلاعات پستی خود را در فرم زیر وارد نمایید و بر روی ثبت اطلاعات پستی کلیک کنید</div>
    <?php else: ?>
            <div class="title_and_edit">
                <p class="title-shipping-info">ویرایش اطلاعات دریافت کننده جایزه</p>
                <button id="avans_cancel_edit_shipping_info">انصراف از ویرایش</button>
            </div>
    <?php endif; ?>
    <hr>

    <div class="avans_wrapper_fields">

        <div class="avs_wrapper_field">
            <label>نام</label>
            <input class="avans_data_shipping" value="<?php echo $fname ?>" type="text" data-type="name" >
        </div>

        <div class="avs_wrapper_field">
            <label>نام خانوادگی</label>
            <input class="avans_data_shipping" value="<?php echo $lname ?>" type="text" data-type="lastname" >
        </div>

    </div>

    <div class="avans_wrapper_fields">

        <div class="avs_wrapper_field">
            <label>استان</label>
            <select data-val="<?php echo $state ?>" class="avans_data_shipping" data-type="state" id="state" >
                <option value="0">استان را انتخاب کنید</option>
                <option value="KHZ">خوزستان</option>
                <option value="THR">تهران</option>
                <option value="ILM">ایلام</option>
                <option value="BHR">بوشهر</option>
                <option value="ADL">اردبیل</option>
                <option value="ESF">اصفهان</option>
                <option value="YZD">یزد</option>
                <option value="KRH">کرمانشاه</option>
                <option value="KRN">کرمان</option>
                <option value="HDN">همدان</option>
                <option value="GZN">قزوین</option>
                <option value="ZJN">زنجان</option>
                <option value="LRS">لرستان</option>
                <option value="ABZ">البرز</option>
                <option value="EAZ">آذربایجان شرقی</option>
                <option value="WAZ">آذربایجان غربی</option>
                <option value="CHB">چهارمحال و بختیاری</option>
                <option value="SKH">خراسان جنوبی</option>
                <option value="RKH">خراسان رضوی</option>
                <option value="NKH">خراسان شمالی</option>
                <option value="SMN">سمنان</option>
                <option value="FRS">فارس</option>
                <option value="QHM">قم</option>
                <option value="KRD">کردستان</option>
                <option value="KBD">کهگیلویه و بویراحمد</option>
                <option value="GLS">گلستان</option>
                <option value="GIL">گیلان</option>
                <option value="MZN">مازندران</option>
                <option value="MKZ">مرکزی</option>
                <option value="HRZ">هرمزگان</option>
                <option value="SBN">سیستان و بلوچستان</option>
            </select>

        
                
        </div>

        <div class="avs_wrapper_field">
            <label>شهرستان</label>
            <input type="text" value="<?php echo $city ?>" class="avans_data_shipping" data-type="city">
        </div>

    </div>

    <div class="avans_wrapper_fields address">

        <div class="avs_wrapper_field">
            <label>آدرس دقیق</label>
            <textarea class="avans_data_shipping" data-type="address"><?php echo $address ?></textarea>
        </div>

    </div>

    <div class="avans_wrapper_fields">

         <div class="avs_wrapper_field">
            <label>کد پستی</label>
            <input value="<?php echo $postcode ?>" class="avans_data_shipping" type="text" data-type="zipcode">
        </div>

        <div class="avs_wrapper_field">
            <label>شماره موبایل</label>
            <input value="<?php echo $phone ?>" class="avans_data_shipping" type="text" data-type="mobile" >
        </div>

    </div>

    <div class="submit_form">
        <button data-order="<?php echo $order->ID ?>" data-ajax="<?php echo admin_url('admin-ajax.php'); ?>" id="avans_submit_shipping_info" class="button button-primary">ثبت اطلاعات پستی</button>
    </div>
</div>

