<?php

use Avans\func;

function avans_lottery_shortcode_callback($atts){
    extract(shortcode_atts(array('id'=> 0), $atts));
    ob_start();

    if (get_current_user_id() == 0) {
        echo "<div class='avans-message'>برای مشاهده فرم ثبت نام در قرعه کشی باید وارد شوید.</div>";
        return ob_get_clean();
    }


    if(get_post_status($id) !== 'publish'){ return ob_get_clean(); }
    $option = get_post_meta($id,AVANS_PREFIX.'lottery_settings',true);
    $members = (array)get_post_meta($id,AVANS_PREFIX.'lottery_members',true);
    $members_repeat = array_count_values($members);
    $data_group = explode(' ',$option['date']);
    $date = Avans\func::convert_jalali_to_miladi($data_group[0]);
    $date_seconds = explode(':',$data_group[1]);
    $whatch = isset($data_group[1]) ? avans_tr_num($date_seconds[0]) .':'. avans_tr_num($date_seconds[1])  : '00:00:00';
    if(is_array($date)){
		$date = $date[0].'/'.$date[1].'/'.$date[2];
	}
    $date_format = $date.' '.$whatch;
    $diference = Avans\func::diference_time_now($date_format);
    ?>
    <div class="avans_wrapper_lottery">

        <div class="lottery_header">
            <div class="col-title">
                <div class="title"><?php echo get_the_title($id) ?></div>
            </div>
            <div class="col-countdown">
                <div class="avans_countdown_lottery"></div> 
            </div>
        </div>
        
        <div class="lottery_description"><?php echo get_the_content(null,false,$id) ?></div>
        <div class="lottery_score_text">
            <?php echo func::get_score_icon(18); ?>
            <?php echo sprintf(__('شما برای دریافت هر بلیط به %d %s نیاز دارید!'),$option['score'],Avans\func::get_score_label()) ?>
        </div>
        <div class="lottery_footer">
            <div class="lottery_chance_all">
                <div class="title_chance">حداکثر بلیط قابل رزرو</div>
                <div class="value_chance"><?php echo $option['max_chance'] ?></div>
            </div>
            <div class="lottery_chance_user">
                <div class="title_chance">بلیط های شما</div>
                <div class="value_chance"><?php echo (int)$members_repeat[get_current_user_id()] ?></div>
            </div>
            <div class="lottery_form">
                
                <?php if($diference > 0): ?>
                <div class="counter">
                    <i class="avans-ic avs-icon-minus decrease"></i>
                    <input type="number" class="avans_counter_tickets" min="1" max="10" value="1">
                    <i class="avans-ic avs-icon-plus-1 increase"></i>
                </div>
                <div class="wrapp_button">
                    <button class="get_ticket avans-button normal" data-plugin-uri="<?php echo AVANS_URI ?>" data-id="<?php echo $id; ?>" data-ajax="<?php echo admin_url('admin-ajax.php'); ?>">تهیه بلیط</button>
                </div>
                <?php endif; ?>
            </div>
        </div>
     

    </div>


        <script defer>
            jQuery(document).ready(function($){
                var countDownDate = new Date("<?php echo $date_format ?>").getTime();
                new get_lottery_countdown_timer(countDownDate);
            });
        </script>

    <?php
    return ob_get_clean();
}

add_shortcode('avans-lottery','avans_lottery_shortcode_callback');