<?php

use Avans\user;

function avans_spin_wheel_callback($atts){
    extract(shortcode_atts(array('id'=> 0), $atts));
    ob_start();
    if (get_current_user_id() == 0) {
        echo "<div class='avans-message'>برای مشاهده گردونه شانس باید وارد شوید</div>";
        return ob_get_clean();
    }

    $settings = get_post_meta($id,AVANS_PREFIX.'spin_wheel_settings',true);
    $user_chance = 0;
    $user_id = get_current_user_id();

    if(isset($settings['is_active_free_spin']) && $settings['is_active_free_spin']){
        if(user::is_permision_get_prize_by_duration_time($settings['duration'],$user_id,$id)){
            $user_chance += 1;
        }
    }
    
    $user_chance = (int)(user::get_score_valid($user_id) / $settings['score']) + $user_chance;

    ?>
    <div class="avans_spin_wrapper" >
        <div id="avans_spin_wheel_holder"></div>
        <div id="avans_result_spin_wheel"></div>
        <button class="avans-button normal" id="avans_rotate_wheel" <?php echo $user_chance == 0 ? 'disabled' : '' ?> >بچرخان</button>
        <div class="avans-spin-wheel-loading lds-ellipsis"><div></div><div></div><div></div><div></div></div>
    </div>

    <?php 
    $styles = [
        'primary' => isset($settings['style']['primary_color']) && !empty($settings['style']['primary_color']) ? $settings['style']['primary_color'] : '#43486a',
        'secondry' => isset($settings['style']['secondry_color']) && !empty($settings['style']['secondry_color']) ? $settings['style']['secondry_color'] : '#fff3c4',
        'text_center' => isset($settings['style']['text_center_color']) && !empty($settings['style']['text_center_color']) ? $settings['style']['text_center_color'] : '#43486a',
    ];

    $data = [
        'list' => $settings['slices'],
        'ajax' => admin_url('admin-ajax.php'),
        'style' => $styles,
        'wheel_id' => $id,
        'chance_user' =>  $user_chance,
    ];
    wp_localize_script('avans_spin_wheel_shortcode_localize_script','avans_spin_wheel',$data);
    wp_enqueue_script('avans_spin_wheel_shortcode_localize_script');
    return ob_get_clean();
}
add_shortcode('avans-spin-wheel','avans_spin_wheel_callback');